<?php

/*////////////////////////////////////////////////////////////

iWare Professional 5.0.4
Copyright (C) 2002,2003 David N. Simmons
http://www.dsiware.com

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

A COPY OF THE GPL LICENSE FOR THIS PROGRAM CAN BE FOUND WITHIN THE
docs/ DIRECTORY OF THE INSTALLATION PACKAGE.

/////////////////////////////////////////////////////////////*/

// Installation Structure Contstants//
define("DIR_SKINS","../skins/");
define("DIR_FILES","../files/");
define("DIR_LANG","lang/");
define("DIR_DOCS","docs/");
define("DIR_EDITOR","editor/");
define("DIR_MODS","mods/");
define("DIR_IMAGES","images/");
define("DIR_EXPORT","export/");

// Program Operation Constants//
define("INIT",0);
define("USERS_MANAGE",1);
define("USERS_CREATE",2);
define("USERS_ADD",3);
define("USERS_EDIT",4);
define("USERS_UPDATE",5);
define("USERS_DELETE",6);
define("GROUPS_MANAGE",7);
define("GROUPS_CREATE",8);
define("GROUPS_ADD",9);
define("GROUPS_EDIT",10);
define("GROUPS_UPDATE",11);
define("GROUPS_DELETE",12);
define("LAYOUT_HEADERMANAGE",13);
define("LAYOUT_HEADERUPDATE",14);
define("LAYOUT_FOOTERMANAGE",15);
define("LAYOUT_FOOTERUPDATE",16);
define("SKINS_MANAGE",17);
define("SKINS_UPDATE",18);
define("DOCS_MANAGE",19);
define("DOCS_CREATE",20);
define("DOCS_ADD",21);
define("DOCS_EDIT",22);
define("DOCS_UPDATE",23);
define("DOCS_DELETE",24);
define("ORDER_MANAGE",25);
define("ORDER_UPDATE",26);
define("FILES_MANAGE",27);
define("FILES_UPLOAD",28);
define("FILES_DELETE",29);
define("MODS_MANAGE",30);
define("MODS_INSTALL",31);
define("MODS_UNINSTALL",32);
define("MODS_USE",33);

// Error Code Constants//
define("ERROR_CONFIG","System Configuration File Not Found, Do you need to INSTALL the application ?");
define("ERROR_LANGUAGE","Language Definition File Not Found, Do you need to INSTALL the application ?");
define("ERROR_SQL","Sql Error :: ".mysql_error());
define("ERROR_TERMINATION","Your session has been terminated by the system. <a href=\"index.php\">RESTART</a>");

// Licensing Constants //
define("PRODUCT_KEY","iWnq2IW4NY65I");
define("AUTHOR_KEY","htA7VzXBZ9XGA");

/**
*iWare Professional Core Application Class
*
*@package iWare Professional
*@version 5.0.4
*@author David N. Simmons
*@copyright 2002,2003,2004
*@license GPL
*
*/
class IWARE {

var $License_ProductName='iWare Professional';
var $License_AuthorName='David N. Simmons';
var $License_AuthorURL='http://www.dsiware.com';

/**
*Stores active database connection handle
*
*@var integer $dbcon
*
*/
var $dbcon;

/**
*Class constructor runs upon initialization of a class object.Verifies that the required configuration and language defiition files are present using Protect_ConfigExists() and Protect_LangExists(). Establishes an initial database connection and selectes the configured database for use using DB_ConnectDb () and DB_SelectDb ().
*
*@access private
*@return void
*
*/
function IWARE ()
	{
	$this->Protect_ConfigExists();
	$this->Protect_LangExists();
	$this->Protect_Auth ();
	if(!session_id()){session_start();}
	$this->DB_ConnectDb (IWARE_HOSTNAME, IWARE_USERNAME, IWARE_PASSWORD);
	$this->DB_SelectDb(IWARE_DATABASE);
	$this->License_Validate();
	if(MAIL_HANDLER=='Win32'){ini_set("SMTP",MAIL_SMTP);}
	}

/**
*Establishes a connection to the MySQL database and stores the active database connection handle to the class var $dbcon.
*
*@access private
*@return void
*@param string $host	Hostname or IP address of the MySQL server
*@param string $user	Username required to access the MySQL database
*@param string $pwd	Password required to access the MySQL database
*
*/
function DB_ConnectDb ($host,$user,$pwd)
	{$link = mysql_connect ($host,$user,$pwd);$this->dbcon = $link;}

/**
*Closes a connection to the MySQL database
*
*@access private
*@return void
*
*/
function DB_CloseDb ()
	{if(!empty($this->dbcon)){mysql_close ($this->dbcon);}}

/**
*Selects a database for use by the application
*
*@access private
*@return void
*@param string $dbname The name of the database to select for use
*
*/
function DB_SelectDb ($dbname)
	{mysql_select_db($dbname,$this->dbcon);}

/**
*Executes a MuySQL query and returns the result
*
*@access public
*@return array
*@param string $sql	Any valid SQL statement to be executed
*
*/
function DB_Query ($sql)
	{$resultset = mysql_query($sql,$this->dbcon) or $this->Error_ThrowError(mysql_error ());return $resultset;}

/**
*Returns data for a given row and field from a sql query result set
*
*@access public
*@return string
*@param array $result	The result set to be used for data retrieval
*@param integer $row	The corresponding row number to retrieve data from
*@param string $field	The corresponding fieldname to retrieve data from
*
*/
function DB_Result ($result,$row,$field)
	{return $this->DB_ParseOutput(mysql_result($result,$row,$field));}

/**
*Returns the last id present from an sql insert query
*
*@access public
*@return integer
*
*/
function DB_GetInsertId ()
	{return mysql_insert_id ();}

/**
*Returns a total count of all rows present in a sql result set
*
*@access public
*@return integer
*@param array $result The result set to count
*
*/
function DB_CountResult ($result)
	{return mysql_num_rows($result);}

/**
*Frees a sql result set from memory
*
*@access public
*@return void
*@param array $result The result set to free from memory
*
*/
function DB_FreeResult ($result)
	{mysql_free_result($result);}

/**
*Returns the current version of the installed MySQL server software
*
*@access public
*@return string
*
*/
function DB_GetServerInfo ()
	{return mysql_get_server_info();}

/**
*Checks if a given table exists in the active database. Returns true if the table exists, false otherwise.
*
*@access private
*@return boolean
*@param string $tablename The table name to check for
*
*/
function DB_TableExists ($tablename)
	{
	$tables = Array ();
	$i=0;
	$result = mysql_list_tables(IWARE_DATABASE);
	if (!$result) {return false;}
	while ($row = mysql_fetch_row($result)) {$tables[$i]=$row[0];$i++;}
	$this->DB_FreeResult($result);
	if (in_array($tablename,$tables)){return true;}
	else {return false;}
	}

/**
*Parses & returns single / double quotes and optionally HTML for database string output
*
*@access private
*@return public
*@param integer $allowHTML When set to 1 the returned input will not be stripped of HTML, defaults to 0
*
*/
function DB_ParseInput ($input,$allowHTML=0)
	{
	$input=trim(addslashes($input));
	if($allowHTML!=1){$input=strip_tags($input);}
	return $input;
	}

/**
*Parses & returns single / double quotes for database string output
*
*@access private
*@return string
*
*/
function DB_ParseOutput ($input){$input=trim(stripslashes($input));return $input;}


/**
*Outputs JavaScript code to generate a popup dialog box
*
*@access public
*@return void
*@param string $msg Text message to be displayed in the popup dialog
*
*/
function UI_Message($msg)
	{echo "<script language=\"JavaScript\">\nwindow.alert('".trim($msg)."');\n</script>";}

/**
*Outputs JavaScript code to redirect a page
*
*@access public
*@return void
*@param string $url Absolute or relative target URL to redirect the page to
*
*/
function UI_Navigate($url)
	{echo "<script language=\"JavaScript\">\nwindow.location='".trim($url)."';\n</script>";}

/**
*Outputs an opening HTML container for user interfaces
*
*@access public
*@return void
*@param string $titlebar	Text to be displayed in the containers titlebar area
*@param integer $size		Optional width in pixels of the container, if none specified the default of 775 will be used
*/
function UI_OpenWidget ($titlebar,$size=775)
	{
	echo "<table border=0 class=\"UI_Widget\" width=".$size." cellpadding=3 cellspacing=0>\n";
	echo "<tr>\n";
	echo "<td class=\"UI_Widget_TitleBar\">".trim($titlebar)."</td>\n";
	echo "</tr>\n";
	echo "<tr>\n";
	echo "<td align=\"center\"  class=\"UI_Widget_Content\">\n";
	}

/**
*Outputs a closing HTML container for user interfaces
*
*@access public
*@return void
*
*/
function UI_CloseWidget ()
	{
	echo "</td>\n</tr>\n<tr>\n<td class=\"UI_Widget_StatusBar\" colspan=\"2\">&nbsp;";
	echo "</td>\n</tr>\n</table>\n";
	}

/**
*Ouputs an opening HTML form for POST data
*
*@access public
*@return void
*@param string $name			The value to be used as the HTML name attribute
*@param string $action			The value to be used as the HTML action attribute
*@param string $onsubmit		The value to be used as the JavaScript onSubmit event
*
*/
function UI_OpenForm ($name,$action,$onsubmit)
	{echo "<form method=POST name=\"".$name."\" action=\"".$action."\" onSubmit=\"".$onsubmit."\">\n";}

/**
*Ouputs an opening HTML form for Multipart/POST data
*
*@access public
*@return void
*@param string $name			The value to be used as the HTML name attribute
*@param string $action			The value to be used as the HTML action attribute
*@param string $onsubmit		The value to be used as the JavaScript onSubmit event
*
*/
function UI_OpenFileForm ($name,$action,$onsubmit)
	{echo "<form enctype=\"multipart/form-data\" method=POST name=\"".$name."\" action=\"".$action."\" onSubmit=\"".$onsubmit."\">\n";}

/**
*Ouputs a closing HTML form tag
*
*@access public
*@return void
*
*/
function UI_CloseForm ()
	{echo "</form>\n";}

/**
*Returns a formatted label for use in user interfaces
*
*@access public
*@return string
*@param string $text	Text to be displayed as the label
*
*/
function UI_Label ($text)
	{return "<font class=\"UI_Label\">".$text."</font>";}

/**
*Returns HTML to output a checkbox form element
*
*@access public
*@return string
*@param string $name			The value to be used as the HTML name attribute
*@param string $value			The value to be used as the HTML value attribute
*@param integer $checked	Optional value specifying if the checkbox initial state is set to checked (1) or unchecked (0), defaults to unchecked (0)
*
*/
function UI_CheckBox ($name,$value,$checked=0)
	{
	$str="<input type=\"checkbox\" name=\"".$name."\" value=\"".$value."\" class=\"UI_CheckBox\" ";
	if($checked==1){$str.= "checked";}
	$str.= " />\n";
	return $str;
	}

/**
*Returns HTML to output a radio option form element
*
*@access public
*@return string
*@param string $name			The value to be used as the HTML name attribute
*@param string $value			The value to be used as the HTML value attribute
*@param integer $checked	Optional value specifying if the checkbox initial state is set to checked (1) or unchecked (0), defaults to unchecked (0)
*
*/
function UI_RadioOption ($name,$value,$checked=0)
	{
	$str="<input type=\"radio\" name=\"".$name."\" value=\"".$value."\" class=\"UI_RadioOption\" ";
	if($checked==1){$str.= "checked";}
	$str.= " />\n";
	return $str;
	}

/**
*Returns HTML to output a text box form element
*
*@access public
*@return string
*@param string $name	The value to be used as the HTML name attribute
*@param string $value	The value to be used as the HTML value attribute
*@param integer $size	The value to be used as the HTML size attribute
*
*/
function UI_TextBox ($name,$value,$size)
	{return "<input type=\"text\" name=\"".$name."\" value=\"".$value."\" size=\"".$size."\" class=\"UI_TextBox\" />\n";}

/**
*Returns HTML to output a password box form element
*
*@access public
*@return string
*@param string $name	The value to be used as the HTML name attribute
*@param string $value	The value to be used as the HTML value attribute
*@param integer $size	The value to be used as the HTML size attribute
*
*/
function UI_PasswordBox ($name,$value,$size)
	{return "<input type=\"password\" name=\"".$name."\" value=\"".$value."\" size=\"".$size."\" class=\"UI_PasswordBox\" />\n";}

/**
*Returns HTML to output a file box form element
*
*@access public
*@return string
*@param string $name	The value to be used as the HTML name attribute
*@param string $value	The value to be used as the HTML value attribute
*@param integer $size	The value to be used as the HTML size attribute
*
*/
function UI_FileBox ($name,$value,$size)
	{return "<input type=\"file\" name=\"".$name."\" value=\"".$value."\" size=\"".$size."\" class=\"UI_FileBox\" />\n";}

/**
*Returns HTML to output a hidden form element
*
*@access public
*@return string
*@param string $name	The value to be used as the HTML name attribute
*@param string $value	The value to be used as the HTML value attribute
*
*/
function UI_Hidden ($name,$value)
	{return "<input type=\"hidden\" name=\"".$name."\" value=\"".$value."\" />\n";}

/**
*Returns HTML to output a text area form element
*
*@access public
*@return string
*@param string $name		The value to be used as the HTML name attribute
*@param string $value		The value to be used as the HTML value attribute
*@param integer $rows		The value to be used as the HTML rows attribute
*@param integer $cols		The value to be used as the HTML cols attribute
*
*/
function UI_TextArea ($name,$value,$rows,$cols)
	{
	$str="<textarea name=\"".$name."\" rows=\"".$rows."\" cols=\"".$cols."\" class=\"UI_TextArea\">".str_replace("'","",$value)."</textarea>\n";
	return $str;
	}

/**
*Outputs HTML for a list box form element
*
*@access public
*@return void
*@param string $name			The value to be used as the HTML name attribute
*@param integer $size			The value to be used as the HTML size attribute
*@param integer $multiple		Optional value indicating whether or not the list box will accept multiple values (1) or single (0), defaults to single (0)
*
*/
function UI_OpenListBox ($name,$size,$multiple=0)
	{
	echo "<select name=\"".$name;
	if($multiple==1){echo "[]";}
	echo "\" size=\"".$size."\" class=\"UI_ListBox\">\n";
	}

/**
*Outputs HTML tfor a list box option form element
*
*@access public
*@return void
*@param string $value			The value to be used as the HTML value attribute
*@param string $label			The text to be displayed as an option
*@param integer $selected	Optional value indicating whether or not the inital state of the option is set to selected (1) or unselected (0), defaults to unselected (0)
*
*/
function UI_ListOption ($value,$label,$selected=0)
	{
	echo "<option value=\"".$value."\" ";
	if ($selected==1){echo " selected ";}
	echo ">".$label."</option>\n";
	}

/**
*Outputs HTML for a closing list box form element
*
*@access public
*@return void
*
*/
function UI_CloseListBox ()
	{echo "</select>\n";}

/**
*Returns HTML to output a submit button form element
*
*@access public
*@return string
*@param string $label	Text to be displayed on the submit button
*
*/
function UI_Submit ($label)
	{return "<input type=\"submit\" value=\"".$label."\" class=\"UI_Submit\" />\n";}

/**
*Returns HTML to output a button form element
*
*@access public
*@return string
*@param string $name		Text to be displayed on the button
*@param string $onclick	Text to use for the buttons JavaScript onClick event
*
*/
function UI_Button ($label,$onclick)
	{return "<input type=\"button\" value=\"".$label."\" onClick=\"".$onclick."\" class=\"UI_Button\" />\n";}

/**
*Ouputs HTML for a page body tag
*
*@access public
*@return void
*
*/
function UI_PageBody ()
	{echo "<body>\n";}

/**
*Outputs HTML for a container widgets opening inner table
*
*@access public
*@return void
*@param integer $width Optional value specifying the width of the inner table in pixels. If no value supplied then the default of 600 will be used
*
*/
function UI_OpenTable ($width='100%')
	{echo "<table border=\"0\" cellpadding=\"3\" cellspacing=\"0\" width=\"".$width."\">\n";}

/**
*Outputs HTML for a container widgets closing inner table
*
*@access public
*@return void
*
*/
function UI_CloseTable ()
	{echo "</table><br />\n";}

/**
*Outputs HTML to create a WYSIWYG enable text area form element
*
*@access public
*@return void
*@param string $value		The value to be used as the HTML value attribute
*@param integer $rows		The value to be used as the HTML rows attribute
*@param integer $cols		The value to be used as the HTML cols attribute
*
*/
function UI_WYSIWYG_Editor ($value,$rows,$cols)
	{
	echo "<textarea id=\"content\" name=\"content\" style=\"width:100%\" rows=\"".$rows."\" cols=\"".$cols."\">".$value."</textarea>\n";
	if (EDITOR_VERSION=='htmlarea')
		{echo "<script language=\"javascript1.2\">editor_generate('content');</script>\n"; }
	}

/**
*Conditionally outputs HTML to create the main application toolbar. Toolbar icons will be created according to permission levels inherited from the current users group using Groups_GetGroupAuth ()
*
*@access public
*@return void
*
*/
function UI_ToolbarControl ()
	{
	$auth=$this->Groups_GetGroupAuth($this->Users_GetUserGroup($this->Session_GetLoginId()));
	echo "<table class=\"UI_Widget\" width=\"775\" cellpadding=\"3\" cellspacing=\"0\">\n";
	echo "<tr>\n";
	echo "<td class=\"UI_Widget_TitleBar\">iWare Professional </td>\n";
	echo "</tr>\n";
	echo "<tr>\n";
	echo "<td align=\"center\" class=\"UI_Widget_Content\">\n";
	$this->UI_OpenTable(750);
	echo "<tr>\n";
	$this->UI_OpenForm('',$_SERVER['PHP_SELF']."?cmd=".INIT."&logout=1",'');
	echo "<td>".$this->UI_Submit(LANG_1)."</td>\n";
	$this->UI_CloseForm();
	$this->UI_OpenForm('',$_SERVER['PHP_SELF']."?cmd=".INIT,'');
	echo "<td>".$this->UI_Submit(LANG_3)."</td>\n";
	$this->UI_CloseForm();
	if($auth['allow_users']==1)
		{
		$this->UI_OpenForm('',$_SERVER['PHP_SELF']."?cmd=".USERS_MANAGE,'');
		echo "<td>".$this->UI_Submit(LANG_5)."</td>\n";
		$this->UI_CloseForm();
		}
	if($auth['allow_groups']==1)
		{
		$this->UI_OpenForm('',$_SERVER['PHP_SELF']."?cmd=".GROUPS_MANAGE,'');
		echo "<td>".$this->UI_Submit(LANG_7)."</td>\n";
		$this->UI_CloseForm();
		}
	if($auth['allow_layout']==1)
		{
		$this->UI_OpenForm('',$_SERVER['PHP_SELF']."?cmd=".LAYOUT_HEADERMANAGE,'');
		echo "<td>".$this->UI_Submit(LANG_9)."</td>\n";
		$this->UI_CloseForm();
		}
	if($auth['allow_layout']==1)
		{
		$this->UI_OpenForm('',$_SERVER['PHP_SELF']."?cmd=".LAYOUT_FOOTERMANAGE,'');
		echo "<td>".$this->UI_Submit(LANG_11)."</td>\n";
		$this->UI_CloseForm();
		}
	if($auth['allow_skins']==1)
		{
		$this->UI_OpenForm('',$_SERVER['PHP_SELF']."?cmd=".SKINS_MANAGE,'');
		echo "<td>".$this->UI_Submit(LANG_13)."</td>\n";
		$this->UI_CloseForm();
		}
	if($auth['allow_docs']==1)
		{
		$this->UI_OpenForm('',$_SERVER['PHP_SELF']."?cmd=".DOCS_MANAGE,'');
		echo "<td>".$this->UI_Submit(LANG_15)."</td>\n";
		$this->UI_CloseForm();
		}
	if($auth['allow_order']==1)
		{
		$this->UI_OpenForm('',$_SERVER['PHP_SELF']."?cmd=".ORDER_MANAGE,'');
		echo "<td>".$this->UI_Submit(LANG_17)."</td>\n";
		$this->UI_CloseForm();
		}
	if($auth['allow_files']==1)
		{
		$this->UI_OpenForm('',$_SERVER['PHP_SELF']."?cmd=".FILES_MANAGE,'');
		echo "<td>".$this->UI_Submit(LANG_19)."</td>\n";
		$this->UI_CloseForm();
		}
	if($auth['allow_mods']==1)
		{
		$this->UI_OpenForm('',$_SERVER['PHP_SELF']."?cmd=".MODS_MANAGE,'');
		echo "<td>".$this->UI_Submit(LANG_21)."</td>\n";
		$this->UI_CloseForm();
		}
	$this->UI_OpenForm('','../','');
	echo "<td>".$this->UI_Button(LANG_23,'SitePreview()')."</a></td>";
	$this->UI_CloseForm();
	echo "</tr>";
	$this->UI_CloseTable();
	echo "</td>\n</tr>\n</table>\n";
	}

/**
* Authenticates a user license and product name
*
*@access private
*/
function License_Validate()
	{
	if(crypt($this->License_ProductName,$this->License_ProductName)!=PRODUCT_KEY)
		{die($this->UI_Navigate('docs/License.txt'));}
	if(crypt($this->License_AuthorURL,$this->License_AuthorURL)!=AUTHOR_KEY)
		{die($this->UI_Navigate('docs/License.txt'));}
	}

/**
*Checks if a user login session is present. Returns true if present, false otherwise.
*
*@access private
*@return boolean
*
*/
function Session_IsLoggedIn()
	{if( !empty($_SESSION['uid'])){return true;}else{return false;}}


/**
*Returns the login id of the current session
*
*@access private
*@return string
*
*/
 function Session_GetLoginId ()
	{return $_SESSION['uid'];}

/**
*Checks if a user is logged in and has a session present. If the user is not logged in then the login interface will be called.
*
*@access private
*@return void
*
*/
 function Session_ShowLoginForm()
	{
	if(!isset($_REQUEST['LOGIN'])){$_REQUEST['LOGIN']="";}
	if(!isset($_REQUEST['username'])){$_REQUEST['username']="";}
	if(!isset($_REQUEST['password'])){$_REQUEST['password']="";}
	$LOGIN=$_REQUEST['LOGIN'];
	$username=$_REQUEST['username'];
	$password=$_REQUEST['password'];
	if ($this->Session_IsLoggedIn())
		return;
	if ($LOGIN == 1)
		{
		if ($this->Session_Logon())
			{
			$this->Session_LoginForm(TRUE);
			exit();
			}
		}
	else
		{
		$this->Session_LoginForm(FALSE);
		exit;
		}
	}


/**
*Attempts to login a user and authenticate the user credentials against the database. Returns false upon a sucessfull authentication, true otherwise.
*
*@access private
*@return boolean
*
*/
 function Session_Logon()
	{
	$username=$this->DB_ParseInput($_REQUEST['username']);
	$password=$this->DB_ParseInput($_REQUEST['password']);
	$this->DB_SelectDb(IWARE_DATABASE);
	$matches = $this->DB_Query("select id,username,password from ".TABLE_USERS."  where username='".$username."' limit 1");
	if ($this->DB_CountResult($matches) > 0)
		{
		$encpassword = $this->DB_Result($matches,0,"password");
		if (crypt($password,$password) == $encpassword)
			{
			$_SESSION['uid'] = $this->DB_Result($matches,0,"id");
			$this->DB_FreeResult($matches);
			if($this->DB_TableExists (TABLE_PREFIX.'mod_syslogs'))
				{$this->Client_LogSystem (0);}
			return FALSE;
			}
		else{return TRUE;}
		}
	$this->DB_FreeResult($matches);
	return TRUE;
	}


/**
*Logs a user out of the application by destroying the active session id
*
*@access private
*@return void
*
*/
function Session_Logoff ()
	{
	if($this->DB_TableExists (TABLE_PREFIX.'mod_syslogs'))
		{$this->Client_LogSystem (1);}
	$_SESSION['uid']='';
	unset($_SESSION['uid']);
	$this->UI_Navigate($_SERVER['PHP_SELF']."?cmd=".INIT);
	}


/**
*outputs the user login interface in two states, first time login and failed login.
*
*@access private
*@return void
*@param boolean $badLogin Boolean value indicating state of login interface. If true then a failed login is assumed.
*
*/
function Session_LoginForm($badLogIn)
	{
	$username=$this->DB_ParseInput($_REQUEST['username']);
	$this->UI_OpenForm("loginForm",$_SERVER['PHP_SELF'],"");
	echo $this->UI_Hidden("LOGIN","1");
	$this->UI_OpenWidget(LANG_24,300);
	$this->UI_OpenTable(250);
	if($badLogIn) {$this->UI_Message(LANG_25);}
	/*
	ATTENTION - Removal of the name, branding, or URL is strictly prohibited and will result in immediate revokation of your license to use this software under the terms of the GPL.
	*/
	echo "<td colspan=\"2\" align=\"center\"><br />\n";
	echo "<img src=\"images/iware_login.jpg\" width=\"200\" height=\"200\" border=\"1\" alt=\"".$this->License_ProductName." \">\n";
	echo "</td>\n";
	echo "<tr>\n";
	echo "<td colspan=\"2\" align=\"center\"><br />\n";
	echo "</td>\n";
	echo "</tr>\n";
	echo "<tr>\n";
	echo "<td colspan=\"2\" align=\"center\">\n";
	echo "</td>\n";
	echo "</tr>\n";
	echo "<tr>\n";
	echo "<td>".$this->UI_Label(LANG_26)."</td><td>".$this->UI_TextBox("username",$username,15)."</td></tr>";
	echo "<tr><td>".$this->UI_Label(LANG_27)."</td><td>".$this->UI_PasswordBox("password","",15)."</td></tr>";
	$this->UI_CloseTable();
	echo $this->UI_Submit(LANG_28)."<br /><br />";
	$this->UI_CloseWidget ();
	$this->UI_CloseForm ();
	}

/**
*Returns an encrypted version of a supplied password string
*
*@access private
*@return string
*@param string $input Password text to be returned in encrypted format
*@see Users__EncryptPassword ()
*
*/
function Session_EncryptPassword ($input)
	{$output = crypt($input,$input);return $output;}


/**
*Ouputs the application system summary showing software versions for the installed platform and counts of defined users, groups, docs, files, skins, and installed modules.
*
*@access public
*@return void
*
*/
function System_Summary ()
	{
	echo "<br />";
	$this->UI_OpenWidget(LANG_29);
	echo "<br />";
	$this->UI_OpenTable(500);
	echo "<tr>\n<td colspan=\"2\" align=\"center\"><img src=\"images/iware_sm.gif\" width=\"130\" height=\"130\" border=\"1\"><br /><br /></td>\n</tr>";
	echo "<tr>\n<td>".$this->UI_Label(LANG_30)."</td>\n<td>".$_SERVER['SERVER_SOFTWARE'] ."</td>\n</tr>";
	echo "<tr>\n<td>".$this->UI_Label(LANG_31)."</td>\n<td>".phpversion ()."</td>\n</tr>";
	echo "<tr>\n<td>".$this->UI_Label(LANG_32)."</td>\n<td>".$this->DB_GetServerInfo ()."</td>\n</tr>";
	echo "<tr>\n<td>".$this->UI_Label(LANG_34)."</td>\n<td>".$this->Users_Count ()."</td>\n</tr>";
	echo "<tr>\n<td>".$this->UI_Label(LANG_35)."</td>\n<td>".$this->Groups_Count ()."</td>\n</tr>";
	echo "<tr>\n<td>".$this->UI_Label(LANG_36)."</td>\n<td>".$this->Docs_Count ()."</td>\n</tr>";
	echo "<tr>\n<td>".$this->UI_Label(LANG_37)."</td>\n<td>".$this->Files_Count ()."</td>\n</tr>";
	echo "<tr>\n<td>".$this->UI_Label(LANG_38)."</td>\n<td>".$this->Skins_Count ()."</td>\n</tr>";
	echo "<tr>\n<td>".$this->UI_Label(LANG_39)."</td>\n<td>".$this->Mod_Count ()."</td>\n</tr>";
	echo "<tr>";
	include ("update.php");
	echo "</tr>";

	$this->UI_CloseTable();
	$this->UI_CloseWidget(1);
	}

/**
*Displays the user management interface
*
*@access private
*@return void
*
*/
function Users_Manager ()
	{
	$auth=$this->Groups_GetGroupAuth($this->Users_GetUserGroup($this->Session_GetLoginId()));
	if($auth['allow_users']==0){$this->Error_CriticalStop (ERROR_TERMINATION);}
	echo "<br />";
	$this->UI_OpenWidget(LANG_40);
	$result=$this->DB_Query("select * from ".TABLE_USERS." order by username");
	$count=$this->DB_CountResult($result);
	echo "<br />";
	$this->UI_OpenTable();
	echo "<tr>";
	echo "<td  align=center class=TableHeader>".$this->UI_Label(LANG_41)."</td>";
	echo "<td  align=center class=TableHeader>".$this->UI_Label(LANG_42)."</td>";
	echo "<td  align=center class=TableHeader>".$this->UI_Label(LANG_43)."</td>";
	echo "<td  align=center class=TableHeader>".$this->UI_Label(LANG_44)."</td>";
	echo "<td  align=center class=TableHeader>".$this->UI_Label(LANG_45)."</td>";
	$this->UI_OpenForm("",$_SERVER['PHP_SELF']."?cmd=".USERS_CREATE,"");
	echo "<td colspan=2 align=center class=TableHeader>".$this->UI_Submit(LANG_46)."</td>";
	$this->UI_CloseForm();
	echo "</tr>";
	$row=0;
	for($i=0;$i<$count;$i++)
		{
		if($row==0){$class="TableRow1";}else{$class="TableRow2";}
		echo "<tr>";
		echo "<td align=center class=\"".$class."\">".date(DATE_FORMAT,$this->DB_Result($result,$i,"added_date"))."</td>";
		echo "<td align=center class=\"".$class."\">".date(DATE_FORMAT,$this->DB_Result($result,$i,"modified_date"))."</td>";
		echo "<td align=center class=\"".$class."\">".$this->Groups_GetGroupName($this->DB_Result($result,$i,"group_id"))."</td>";
		echo "<td class=\"".$class."\">".$this->DB_Result($result,$i,"username")."</td>";
		echo "<td class=\"".$class."\">".$this->DB_Result($result,$i,"realname")."</td>";
		$this->UI_OpenForm("",$_SERVER['PHP_SELF']."?cmd=".USERS_EDIT."&id=".$this->DB_Result($result,$i,"id"),"");
		echo "<td  align=center class=\"".$class."\">".$this->UI_Submit(LANG_47)."</td>";
		$this->UI_CloseForm();
		if($this->DB_Result($result,$i,"id")==1)
			{echo "<td  align=center class=\"".$class."\">".$this->UI_Label("X")."</td>";}
		else
			{
			$this->UI_OpenForm("",$_SERVER['PHP_SELF']."?cmd=".USERS_DELETE."&id=".$this->DB_Result($result,$i,"id"),"return Users_ConfirmDelete ()");
			echo "<td  align=center class=\"".$class."\">".$this->UI_Submit(LANG_48)."</td>";
			$this->UI_CloseForm();
			}
		echo "</tr>";
		if($row==0){$row=1;}else{$row=0;}
		}
	$this->UI_CloseTable();
	$this->DB_FreeResult($result);
	$this->UI_CloseWidget();
	}

/**
*Displays the user account form in one of two states add or edit mode
*
*@access private
*@return void
*@param integer $mode	Value indicating whether to output the form in add (0) or edit (1) mode
*@param integer $id			Optional record id of the record to use when in edit mode (1), in add (0) mode will default to nothing
*
*/
function Users_Form ($mode,$id='')
	{
	$auth=$this->Groups_GetGroupAuth($this->Users_GetUserGroup($this->Session_GetLoginId()));
	if($auth['allow_users']==0){$this->Error_CriticalStop (ERROR_TERMINATION);}
	if($mode==1)
		{
		$result=$this->DB_Query("select * from ".TABLE_USERS." where id='".$id."' limit 1");
		$group_id=$this->DB_Result($result,0,"group_id");
		$realname=$this->DB_Result($result,0,"realname");
		$username=$this->DB_Result($result,0,"username");
		$password=$this->DB_Result($result,0,"password");
		$this->DB_FreeResult($result);
		$this->UI_OpenForm("usersForm",$_SERVER['PHP_SELF']."?cmd=".USERS_UPDATE."&id=".$id,"return Users_Form()");
		$this->UI_OpenWidget(LANG_49);
		}
	elseif($mode==0)
		{
		$group_id="";$realname="";$username="";$password="";
		$this->UI_OpenForm("usersForm",$_SERVER['PHP_SELF']."?cmd=".USERS_ADD,"return Users_Form()");
		$this->UI_OpenWidget(LANG_50);
		}
	$this->UI_OpenTable ();
	echo "<tr><td>".$this->UI_Label(LANG_51)."</td><td>";
	$this->UI_OpenListBox("group_id",1);
	if($mode==1){echo $this->UI_ListOption($group_id,$this->Groups_GetGroupName($group_id),1);}
	$this->Groups_ListBox ();
	$this->UI_CloseListBox ();
	echo "</td></tr>";
	echo "<tr><td>".$this->UI_Label(LANG_52)."</td>";
	echo "<td>".$this->UI_TextBox("realname",$realname,30)."</td></tr>";
	echo "<tr><td>".$this->UI_Label(LANG_53)."</td>";
	echo "<td>".$this->UI_TextBox("username",$username,15)."</td></tr>";
	echo "<tr><td>".$this->UI_Label(LANG_54)."</td>";
	echo "<td>".$this->UI_PasswordBox("password",$password,15)."</td></tr>";
	echo "<tr><td>".$this->UI_Label(LANG_55)."</td>";
	echo "<td>".$this->UI_PasswordBox("cpassword",$password,15)."</td></tr>";
	$this->UI_CloseTable ();
	if($mode==1){echo $this->UI_Submit(LANG_56);}
	elseif($mode==0){echo $this->UI_Submit(LANG_57);}
	$this->UI_CloseWidget();
	$this->UI_CloseForm();
	}

/**
*Adds a user account to the database with a password stored in encypted format
*
*@access private
*@return void
*
*/
function Users_Add ()
	{
	$auth=$this->Groups_GetGroupAuth($this->Users_GetUserGroup($this->Session_GetLoginId()));
	if($auth['allow_users']==0){$this->Error_CriticalStop (ERROR_TERMINATION);}
	$added=strtotime(date(DATE_FORMAT));
	$group_id=trim($_REQUEST['group_id']);
	$realname=$this->DB_ParseInput($_REQUEST['realname']);
	$username=$this->DB_ParseInput($_REQUEST['username']);
	$password=$this->DB_ParseInput($_REQUEST['password']);
	$password=$this->Users_EncryptPassword ($password);
	if($this->Users_UsernameExists($username)){$this->UI_Message(LANG_58);}
	else
		{
		$this->DB_Query("insert into ".TABLE_USERS." (added_date, modified_date, group_id, realname, username, password) values ('".$added."','".$added."','".$group_id."','".$realname."','".$username."','".$password."')");
		$this->UI_Message(LANG_59);
		}
	$this->UI_Navigate($_SERVER['PHP_SELF']."?cmd=".USERS_MANAGE);
	}

/**
*Updates changes made to a user account. If required re-encrypts the password for the account.
*
*@access private
*@return void
*@param integer $id The record id of the user account
*
*/
function Users_Update ($id)
	{
	$auth=$this->Groups_GetGroupAuth($this->Users_GetUserGroup($this->Session_GetLoginId()));
	if($auth['allow_users']==0){$this->Error_CriticalStop (ERROR_TERMINATION);}
	$modified=strtotime(date(DATE_FORMAT));
	$group_id=trim($_REQUEST['group_id']);
	$realname=$this->DB_ParseInput($_REQUEST['realname']);
	$username=$this->DB_ParseInput($_REQUEST['username']);
	$password=$this->DB_ParseInput($_REQUEST['password']);
	if($this->Users_PasswordChanged($id,$password)){$password=$this->Users_EncryptPassword ($password);}
	$this->DB_Query("update ".TABLE_USERS." set modified_date='".$modified."', group_id='".$group_id."', realname='".$realname."', username='".$username."', password='".$password."' where id='".$id."' limit 1");
	$this->UI_Message(LANG_60);
	$this->UI_Navigate($_SERVER['PHP_SELF']."?cmd=".USERS_MANAGE);
	}

/**
*Deletes a user account from the database
*
*@access private
*@return void
*@param integer $id Record id of the user account to be deleted
*
*/
function Users_Delete ($id)
	{
	$auth=$this->Groups_GetGroupAuth($this->Users_GetUserGroup($this->Session_GetLoginId()));
	if($auth['allow_users']==0){$this->Error_CriticalStop (ERROR_TERMINATION);}
	$result=$this->DB_Query("delete from ".TABLE_USERS." where id='".$id."' limit 1");
	$this->DB_Query("update ".TABLE_DOCS." set added_user='1' where added_user='".$id."' ");
	$this->UI_Message(LANG_61);
	$this->UI_Navigate($_SERVER['PHP_SELF']."?cmd=".USERS_MANAGE);
	}

/**
*Returns a boolean value indicating if a user account password has been changed. Returns true if there is a change, false otherwise.
*
*@access private
*@return boolean
*@param integer $id The record id of te user account to compare
*@param string $password The un-encrypted password text to compare
*
*/
function Users_PasswordChanged ($id,$password)
	{
	$result=$this->DB_Query("select password from ".TABLE_USERS." where id='".$id."' limit 1");
	$ExistingPassword=$this->DB_Result($result,0,"password");
	$this->DB_FreeResult($result);
	if($ExistingPassword != $this->Users_EncryptPassword ($password)){return true;}
	else{return false;}
	}

/**
*Returns an encrypted version of a supplied password string
*
*@access private
*@return string
*@param string $password The password text to be returned in encrypted format
*@see Session_EncryptPassword ()
*
*/
function Users_EncryptPassword ($password)
	{return crypt($password,$password);}

/**
*Returns a count of all user accounts defined within the application
*
*@access private
*@return integer
*
*/
function Users_Count ()
	{
	$result=$this->DB_Query("select id from ".TABLE_USERS);
	$count=$this->DB_CountResult($result);
	$this->DB_FreeResult($result);
	return $count;
	}

/**
*Returns the username data for a requested user account
*
*@access private
*@return string
*@param integer $id The record id of the user account
*
*/
function Users_GetUserName ($id)
	{
	$result=$this->DB_Query("select username from ".TABLE_USERS." where id='".$id."' limit 1");
	$username=$this->DB_Result($result,0,"username");
	$this->DB_FreeResult($result);
	return $username;
	}

/**
*Returns the group id data for a requested user account
*
*@access private
*@return integer
*@param integer $id The record id of the user account
*
*/
function Users_GetUserGroup ($id)
	{
	$result=$this->DB_Query("select group_id from ".TABLE_USERS." where id='".$id."' limit 1");
	$group=$this->DB_Result($result,0,"group_id");
	$this->DB_FreeResult($result);
	return $group;
	}

/**
*Outputs a series of HTML option tags containg user ids and usernames
*
*@access private
*@return void
*
*/
function Users_ListBox ()
	{
	$result=$this->DB_Query("select id,username from ".TABLE_USERS." order by username");
	for($i=0;$i<$this->DB_CountResult($result);$i++)
		{echo $this->UI_ListOption($this->DB_Result($result,$i,"id"),$this->DB_Result($result,$i,"username"),0);}
	$this->DB_FreeResult($result);
	}

/**
*Returns a boolean value indicating if a username exists in the application. Returns true if the username exists, false otherwise
*
*@access private
*@return boolean
*@param string $username The username to check
*
*/
function Users_UsernameExists ($username)
	{
	$result=$this->DB_Query("select username from ".TABLE_USERS." where username='".trim($username)."' limit 1");
	$count=$this->DB_CountResult($result);
	$this->DB_FreeResult($result);
	if($count>0){return true;}
	else{return false;}
	}

/**
*Displays the user group management interface
*
*@access private
*@return void
*
*/
function Groups_Manager ()
	{
	$auth=$this->Groups_GetGroupAuth($this->Users_GetUserGroup($this->Session_GetLoginId()));
	if($auth['allow_groups']==0){$this->Error_CriticalStop (ERROR_TERMINATION);}
	echo "<br />";
	$this->UI_OpenWidget(LANG_62);
	$result=$this->DB_Query("select * from ".TABLE_GROUPS." order by groupname");
	$count=$this->DB_CountResult($result);
	echo "<br />";
	$this->UI_OpenTable();
	echo "<tr>";
	echo "<td class=TableHeader>".$this->UI_Label(LANG_63)."</td>";
	echo "<td class=TableHeader>".$this->UI_Label(LANG_64)."</td>";
	echo "<td class=TableHeader>".$this->UI_Label(LANG_65)."</td>";
	echo "<td class=TableHeader>".$this->UI_Label(LANG_66)."</td>";
	$this->UI_OpenForm("",$_SERVER['PHP_SELF']."?cmd=".GROUPS_CREATE,"");
	echo "<td colspan=2 class=TableHeader>".$this->UI_Submit(LANG_67)."</td>";
	$this->UI_CloseForm();
	echo "</tr>";
	$row=0;
	for($i=0;$i<$count;$i++)
		{
		if($row==0){$class="TableRow1";}else{$class="TableRow2";}
		echo "<tr>";
		echo "<td class=\"".$class."\">".date(DATE_FORMAT,$this->DB_Result($result,$i,"added_date"))."</td>";
		echo "<td class=\"".$class."\">".date(DATE_FORMAT,$this->DB_Result($result,$i,"modified_date"))."</td>";
		echo "<td class=\"".$class."\">".$this->DB_Result($result,$i,"groupname")."</td>";
		echo "<td class=\"".$class."\">".$this->Groups_CountUserAccounts ($this->DB_Result($result,$i,"id"))."</td>";
		$this->UI_OpenForm("",$_SERVER['PHP_SELF']."?cmd=".GROUPS_EDIT."&id=".$this->DB_Result($result,$i,"id"),"");
		echo "<td class=\"".$class."\">".$this->UI_Submit(LANG_68)."</td>";
		$this->UI_CloseForm();
		if($this->DB_Result($result,$i,"id")==1)
			{echo "<td  align=center class=\"".$class."\">".$this->UI_Label("X")."</td>";}
		else
			{
			$this->UI_OpenForm("",$_SERVER['PHP_SELF']."?cmd=".GROUPS_DELETE."&id=".$this->DB_Result($result,$i,"id"),"return Groups_ConfirmDelete ()");
			echo "<td class=\"".$class."\">".$this->UI_Submit(LANG_69)."</td>";
			$this->UI_CloseForm();
			}
		echo "</tr>";
		if($row==0){$row=1;}else{$row=0;}
		}
	$this->UI_CloseTable();
	$this->DB_FreeResult($result);
	$this->UI_CloseWidget();
	}

/**
*Displays the user groups form in one of two states add or edit mode
*
*@access private
*@return void
*@param integer $mode	Value indicating whether to output the form in add (0) or edit (1) mode
*@param integer $id			Optional record id of the record to use when in edit mode (1), in add (0) mode will default to nothing
*
*/
function Groups_Form ($mode,$id='')
	{
	$auth=$this->Groups_GetGroupAuth($this->Users_GetUserGroup($this->Session_GetLoginId()));
	if($auth['allow_groups']==0){$this->Error_CriticalStop (ERROR_TERMINATION);}
	if($mode==1)
		{
		$result=$this->DB_Query("select * from ".TABLE_GROUPS." where id='".$id."' limit 1");
		$modified=strtotime(date(DATE_FORMAT));
		$groupname=$this->DB_Result($result,0,"groupname");
		$allow_users=$this->DB_Result($result,0,"allow_users");
		$allow_groups=$this->DB_Result($result,0,"allow_groups");
		$allow_layout=$this->DB_Result($result,0,"allow_layout");
		$allow_skins=$this->DB_Result($result,0,"allow_skins");
		$allow_docs=$this->DB_Result($result,0,"allow_docs");
		$allow_order=$this->DB_Result($result,0,"allow_order");
		$allow_files=$this->DB_Result($result,0,"allow_files");
		$allow_mods=$this->DB_Result($result,0,"allow_mods");
		$this->DB_FreeResult($result);
		$this->UI_OpenForm("groupsForm",$_SERVER['PHP_SELF']."?cmd=".GROUPS_UPDATE."&id=".$id,"return Groups_Form()");
		$this->UI_OpenWidget(LANG_70);
		}
	elseif($mode==0)
		{
		$groupname="";$allow_users=0;$allow_groups=0;$allow_layout=0;
		$allow_skins=0;$allow_docs=0;$allow_order=0;$allow_files=0;$allow_mods=0;
		$this->UI_OpenForm("groupsForm",$_SERVER['PHP_SELF']."?cmd=".GROUPS_ADD,"return Groups_Form()");
		$this->UI_OpenWidget(LANG_71);
		}
	$this->UI_OpenTable ();
	echo "<tr><td>".$this->UI_Label(LANG_72)."</td>";
	echo "<td>".$this->UI_TextBox("groupname",$groupname,30)."</td></tr>";
	echo "<tr><td>";
	$this->UI_OpenListBox("allow_users",1);
	if($mode==1){echo $this->UI_ListOption($allow_users,($allow_users==1)?"Yes":"No",1);}
	echo $this->UI_ListOption("1",LANG_81,0);
	echo $this->UI_ListOption("0",LANG_82,0);
	$this->UI_CloseListBox ();
	echo "</td><td>".$this->UI_Label(LANG_73)."</td></tr>";
	echo "<tr><td>";
	$this->UI_OpenListBox("allow_groups",1);
	if($mode==1){echo $this->UI_ListOption($allow_groups,($allow_groups==1)?"Yes":"No",1);}
	echo $this->UI_ListOption("1",LANG_81,0);
	echo $this->UI_ListOption("0",LANG_82,0);
	$this->UI_CloseListBox ();
	echo "</td><td>".$this->UI_Label(LANG_74)."</td></tr>";
	echo "<tr><td>";
	$this->UI_OpenListBox("allow_layout",1);
	if($mode==1){echo $this->UI_ListOption($allow_layout,($allow_layout==1)?"Yes":"No",1);}
	echo $this->UI_ListOption("1",LANG_81,0);
	echo $this->UI_ListOption("0",LANG_82,0);
	$this->UI_CloseListBox ();
	echo "</td><td>".$this->UI_Label(LANG_75)."</td></tr>";
	echo "<tr><td>";
	$this->UI_OpenListBox("allow_skins",1);
	if($mode==1){echo $this->UI_ListOption($allow_skins,($allow_skins==1)?"Yes":"No",1);}
	echo $this->UI_ListOption("1",LANG_81,0);
	echo $this->UI_ListOption("0",LANG_82,0);
	$this->UI_CloseListBox ();
	echo "</td><td>".$this->UI_Label(LANG_76)."</td></tr>";
	echo "<tr><td>";
	$this->UI_OpenListBox("allow_order",1);
	if($mode==1){echo $this->UI_ListOption($allow_order,($allow_order==1)?"Yes":"No",1);}
	echo $this->UI_ListOption("1",LANG_81,0);
	echo $this->UI_ListOption("0",LANG_82,0);
	$this->UI_CloseListBox ();
	echo "</td><td>".$this->UI_Label(LANG_77)."</td></tr>";
	echo "<tr><td>";
	$this->UI_OpenListBox("allow_docs",1);
	if($mode==1){echo $this->UI_ListOption($allow_docs,($allow_docs==1)?"Yes":"No",1);}
	echo $this->UI_ListOption("1",LANG_81,0);
	echo $this->UI_ListOption("0",LANG_82,0);
	$this->UI_CloseListBox ();
	echo "</td><td>".$this->UI_Label(LANG_78)."</td></tr>";
	echo "<tr><td>";
	$this->UI_OpenListBox("allow_files",1);
	if($mode==1){echo $this->UI_ListOption($allow_files,($allow_files==1)?"Yes":"No",1);}
	echo $this->UI_ListOption("1",LANG_81,0);
	echo $this->UI_ListOption("0",LANG_82,0);
	$this->UI_CloseListBox ();
	echo "</td><td>".$this->UI_Label(LANG_79)."</td></tr>";
	echo "<tr><td>";
	$this->UI_OpenListBox("allow_mods",1);
	if($mode==1){echo $this->UI_ListOption($allow_mods,($allow_mods==1)?"Yes":"No",1);}
	echo $this->UI_ListOption("1",LANG_81,0);
	echo $this->UI_ListOption("0",LANG_82,0);
	$this->UI_CloseListBox ();
	echo "</td><td>".$this->UI_Label(LANG_80)."</td></tr>";
	$this->UI_CloseTable ();
	if($mode==1){echo $this->UI_Submit(LANG_83);}
	elseif($mode==0){echo $this->UI_Submit(LANG_84);}
	$this->UI_CloseWidget();
	$this->UI_CloseForm();
	}

/**
*Adds a user group to the database
*
*@access private
*@return void
*
*/
function Groups_Add ()
	{
	$auth=$this->Groups_GetGroupAuth($this->Users_GetUserGroup($this->Session_GetLoginId()));
	if($auth['allow_groups']==0){$this->Error_CriticalStop (ERROR_TERMINATION);}
	$added=strtotime(date(DATE_FORMAT));
	$groupname=$this->DB_ParseInput($_REQUEST['groupname']);
	$allow_users=$_REQUEST['allow_users'];
	$allow_groups=$_REQUEST['allow_groups'];
	$allow_layout=$_REQUEST['allow_layout'];
	$allow_skins=$_REQUEST['allow_skins'];
	$allow_docs=$_REQUEST['allow_docs'];
	$allow_order=$_REQUEST['allow_order'];
	$allow_files=$_REQUEST['allow_files'];
	$allow_mods=$_REQUEST['allow_mods'];
	if($this->Groups_GroupnameExists($groupname)){$this->UI_Message(LANG_85);}
	else
		{
		$this->DB_Query("insert into ".TABLE_GROUPS." (added_date, modified_date, groupname, allow_users, allow_groups, allow_layout, allow_skins, allow_order, allow_docs, allow_files, allow_mods) values ('".$added."','".$added."','".$groupname."','".$allow_users."','".$allow_groups."','".$allow_layout."','".$allow_skins."','".$allow_order."','".$allow_docs."','".$allow_files."','".$allow_mods."')");
		$this->UI_Message(LANG_86);
		}
	$this->UI_Navigate($_SERVER['PHP_SELF']."?cmd=".GROUPS_MANAGE);
	}

/**
*Updates changes made to a user group.
*
*@access private
*@return void
*@param integer $id The record id of the user group
*
*/
function Groups_Update ($id)
	{
	$auth=$this->Groups_GetGroupAuth($this->Users_GetUserGroup($this->Session_GetLoginId()));
	if($auth['allow_groups']==0){$this->Error_CriticalStop (ERROR_TERMINATION);}
	$modified=strtotime(date(DATE_FORMAT));
	$groupname=$this->DB_ParseInput($_REQUEST['groupname']);
	$allow_users=$_REQUEST['allow_users'];
	$allow_groups=$_REQUEST['allow_groups'];
	$allow_layout=$_REQUEST['allow_layout'];
	$allow_skins=$_REQUEST['allow_skins'];
	$allow_docs=$_REQUEST['allow_docs'];
	$allow_order=$_REQUEST['allow_order'];
	$allow_files=$_REQUEST['allow_files'];
	$allow_mods=$_REQUEST['allow_mods'];
	$this->DB_Query("update ".TABLE_GROUPS." set modified_date='".$modified."', groupname='".$groupname."', allow_users='".$allow_users."', allow_groups='".$allow_groups."', allow_layout='".$allow_layout."', allow_layout='".$allow_skins."', allow_layout='".$allow_docs."', allow_layout='".$allow_order."', allow_layout='".$allow_files."', allow_layout='".$allow_mods."' where id='".$id."' limit 1");
	$this->UI_Message(LANG_87);
	$this->UI_Navigate($_SERVER['PHP_SELF']."?cmd=".GROUPS_MANAGE);
	}

/**
*Deletes a user group from the database
*
*@access private
*@return void
*@param integer $id Record id of the user account to be deleted
*
*/
function Groups_Delete ($id)
	{
	$auth=$this->Groups_GetGroupAuth($this->Users_GetUserGroup($this->Session_GetLoginId()));
	if($auth['allow_groups']==0){$this->Error_CriticalStop (ERROR_TERMINATION);}
	if($this->Groups_HasUserAccounts ($id))
		{$this->UI_Message(LANG_88);}
	else
		{
		$result=$this->DB_Query("delete from ".TABLE_GROUPS." where id='".$id."' limit 1");
		$this->UI_Message(LANG_89);
		}
	$this->UI_Navigate($_SERVER['PHP_SELF']."?cmd=".GROUPS_MANAGE);
	}

/**
*Returns a count of all user groups defined within the application
*
*@access private
*@return integer
*
*/
function Groups_Count ()
	{
	$result=$this->DB_Query("select id from ".TABLE_GROUPS);
	$count=$this->DB_CountResult($result);
	$this->DB_FreeResult($result);
	return $count;
	}

/**
*Returns the groupname data for a requested user group
*
*@access private
*@return string
*@param integer $id The record id of the user group
*
*/
function Groups_GetGroupName ($id)
	{
	$result=$this->DB_Query("select groupname from ".TABLE_GROUPS." where id='".$id."' limit 1");
	$groupname=$this->DB_Result($result,0,"groupname");
	$this->DB_FreeResult($result);
	return $groupname;
	}

/**
*Outputs a series of HTML option tags containg user group ids and groupnames
*
*@access private
*@return void
*
*/
function Groups_ListBox ()
	{
	$result=$this->DB_Query("select id,groupname from ".TABLE_GROUPS." order by groupname");
	for($i=0;$i<$this->DB_CountResult($result);$i++)
		{echo $this->UI_ListOption($this->DB_Result($result,$i,"id"),$this->DB_Result($result,$i,"groupname"),0);}
	$this->DB_FreeResult($result);
	}

/**
*Returns an associative array containing permission settings for a requested group
*
*@access private
*@return array
*@param integer $id The record id of the user group
*
*/
function Groups_GetGroupAuth ($id)
	{
	$auth=Array ();
	$result=$this->DB_Query("select * from ".TABLE_GROUPS." where id='".$id."' limit 1");
	$auth['allow_users']=$this->DB_Result($result,0,"allow_users");
	$auth['allow_groups']=$this->DB_Result($result,0,"allow_groups");
	$auth['allow_layout']=$this->DB_Result($result,0,"allow_layout");
	$auth['allow_skins']=$this->DB_Result($result,0,"allow_skins");
	$auth['allow_docs']=$this->DB_Result($result,0,"allow_docs");
	$auth['allow_order']=$this->DB_Result($result,0,"allow_order");
	$auth['allow_files']=$this->DB_Result($result,0,"allow_files");
	$auth['allow_mods']=$this->DB_Result($result,0,"allow_mods");
	$this->DB_FreeResult($result);
	return $auth;
	}

/**
*Returns a boolean value indicating if a groupname exists in the application. Returns true if the groupname exists, false otherwise
*
*@access private
*@return boolean
*@param string $groupname The groupname to check
*
*/
function Groups_GroupnameExists ($groupname)
	{
	$result=$this->DB_Query("select groupname from ".TABLE_GROUPS." where groupname='".trim($groupname)."' limit 1");
	$count=$this->DB_CountResult($result);
	$this->DB_FreeResult($result);
	if($count>0){return true;}
	else{return false;}
	}

/**
*Returns a boolean value indicating if a group has user accounts that belong to the group. Returns true if the dependancy exists, false otherwise
*
*@access private
*@return boolean
*@param string $id The record id of the user group
*
*/
function Groups_HasUserAccounts ($id)
	{
	$result=$this->DB_Query("select id from ".TABLE_USERS." where group_id='".$id."' limit 1");
	$count=$this->DB_CountResult($result);
	$this->DB_FreeResult($result);
	if($count>0){return true;}
	else{return false;}
	}

/**
*Returns a count of user accounts that belong to a user group
*
*@access private
*@return integer
*@param integer $id The record id of the user group
*
*/
function Groups_CountUserAccounts ($id)
	{
	$result=$this->DB_Query("select id from ".TABLE_USERS." where group_id='".$id."' limit 1");
	$count=$this->DB_CountResult($result);
	$this->DB_FreeResult($result);
	return $count;
	}

/**
*Displays the site header authoring interface
*
*@access private
*@return void
*
*/
function Layout_HeaderManager ()
	{
	$auth=$this->Groups_GetGroupAuth($this->Users_GetUserGroup($this->Session_GetLoginId()));
	if($auth['allow_layout']==0){$this->Error_CriticalStop (ERROR_TERMINATION);}
	$result=$this->DB_Query("select * from ".TABLE_LAYOUT." limit 1");
	$use_header=$this->DB_Result($result,0,"use_header");
	$header=trim($this->DB_Result($result,0,"header"));
	$this->DB_FreeResult($result);
	$this->UI_OpenForm("",$_SERVER['PHP_SELF']."?cmd=".LAYOUT_HEADERUPDATE,"");
	$this->UI_OpenWidget(LANG_90);
	$this->UI_OpenTable();
	echo "<tr><td width=200>".$this->UI_Label(LANG_91)." ";
	$this->UI_OpenListBox("use_header",1);
	echo $this->UI_ListOption($use_header,($use_header==1)?LANG_92:LANG_93,1);
	echo $this->UI_ListOption("1",LANG_92,0);
	echo $this->UI_ListOption("0",LANG_93,0);
	$this->UI_CloseListBox ();
	echo "</td></tr>";
	echo "<tr><td>";
	$this->UI_WYSIWYG_Editor ($header,5,60);
	echo "</td></tr>";
	$this->UI_CloseTable();
	echo $this->UI_Submit(LANG_94);
	$this->UI_CloseWidget();
	$this->UI_CloseForm();
	}

/**
*Displays the site footer authoring interface
*
*@access private
*@return void
*
*/
function Layout_FooterManager ()
	{
	$auth=$this->Groups_GetGroupAuth($this->Users_GetUserGroup($this->Session_GetLoginId()));
	if($auth['allow_layout']==0){$this->Error_CriticalStop (ERROR_TERMINATION);}
	$result=$this->DB_Query("select * from ".TABLE_LAYOUT." limit 1");
	$use_footer=$this->DB_Result($result,0,"use_footer");
	$footer=trim($this->DB_Result($result,0,"footer"));
	$this->DB_FreeResult($result);
	$this->UI_OpenForm("",$_SERVER['PHP_SELF']."?cmd=".LAYOUT_FOOTERUPDATE,"");
	$this->UI_OpenWidget(LANG_95);
	$this->UI_OpenTable();
	echo "<tr><td>".$this->UI_Label(LANG_96)." ";
	$this->UI_OpenListBox("use_footer",1);
	echo $this->UI_ListOption($use_footer,($use_footer==1)?LANG_97:LANG_98,1);
	echo $this->UI_ListOption("1",LANG_97,0);
	echo $this->UI_ListOption("0",LANG_98,0);
	$this->UI_CloseListBox ();
	echo "</td></tr>";
	echo "<tr><td>";
	$this->UI_WYSIWYG_Editor ($footer,5,60);
	echo "</td></tr>";
	$this->UI_CloseTable();
	echo $this->UI_Submit(LANG_99);
	$this->UI_CloseWidget();
	$this->UI_CloseForm();
	}

/**
*Updates changes made to the site header from Layout_HeaderManager ()
*
*@access private
*@return void
*@see Layout_HeaderManager ()
*
*/
function Layout_HeaderUpdate ()
	{
	$auth=$this->Groups_GetGroupAuth($this->Users_GetUserGroup($this->Session_GetLoginId()));
	if($auth['allow_layout']==0){$this->Error_CriticalStop (ERROR_TERMINATION);}
	$use_header=$_REQUEST['use_header'];
	$header=$_REQUEST['content'];
	$this->DB_Query("update ".TABLE_LAYOUT." set use_header='".$use_header."', header='".$header."' ");
	$this->UI_Message(LANG_100);
	$this->UI_Navigate($_SERVER['PHP_SELF']."?cmd=".LAYOUT_HEADERMANAGE);
	}

/**
*Updates changes made to the site footer from Layout_FooterManager ()
*
*@access private
*@return void
*@see Layout_FooterManager ()
*
*/
function Layout_FooterUpdate ()
	{
	$auth=$this->Groups_GetGroupAuth($this->Users_GetUserGroup($this->Session_GetLoginId()));
	if($auth['allow_layout']==0){$this->Error_CriticalStop (ERROR_TERMINATION);}
	$use_footer=$_REQUEST['use_footer'];
	$footer=$_REQUEST['content'];
	$this->DB_Query("update ".TABLE_LAYOUT." set use_footer='".$use_footer."', footer='".$footer."' ");
	$this->UI_Message(LANG_101);
	$this->UI_Navigate($_SERVER['PHP_SELF']."?cmd=".LAYOUT_FOOTERMANAGE);
	}

/**
*Displays the skins selection interface
*
*@access private
*@return void
*
*/
function Skins_Form ()
	{
	$auth=$this->Groups_GetGroupAuth($this->Users_GetUserGroup($this->Session_GetLoginId()));
	if($auth['allow_skins']==0){$this->Error_CriticalStop (ERROR_TERMINATION);}
	$result=$this->DB_Query("select skin from ".TABLE_LAYOUT." limit 1");
	$skin=$this->DB_Result($result,0,"skin");
	$this->DB_FreeResult($result);
	$this->UI_OpenForm("",$_SERVER['PHP_SELF']."?cmd=".SKINS_UPDATE,"");
	$this->UI_OpenWidget(LANG_102);
	echo "<br />";
	$this->Skins_PreviewImage ($skin);
	echo "<br /><br />";
	$this->UI_OpenListBox("skin",1);
	echo $this->UI_ListOption($skin,$skin,1);
	$this->Skins_ListBox ();
	$this->UI_CloseListBox ();
	echo "  ".$this->UI_Submit(LANG_103);
	echo "<br /><br />";
	$this->UI_CloseWidget();
	$this->UI_CloseForm();
	}

/**
*Updates changes made to the site skin from Skins_Form ()
*
*@access private
*@return void
*@see Skins_Form ()
*
*/
function Skins_Update ()
	{
	$auth=$this->Groups_GetGroupAuth($this->Users_GetUserGroup($this->Session_GetLoginId()));
	if($auth['allow_skins']==0){$this->Error_CriticalStop (ERROR_TERMINATION);}
	$skin=$_REQUEST['skin'];
	$this->DB_Query("update ".TABLE_LAYOUT." set skin='".$skin."' limit 1");
	$this->UI_Message(LANG_104);
	$this->UI_Navigate($_SERVER['PHP_SELF']."?cmd=".SKINS_MANAGE);
	}

/**
*Outputs a series of HTML option tags containing skin names
*
*@access private
*@return void
*
*/
function Skins_ListBox ()
	{
	if ($handle = opendir(DIR_SKINS))
		{
		while (false !== ($file = readdir($handle))){if ($file != "." && $file != ".."){$this->UI_ListOption("$file","$file");}}
		closedir($handle);
		}
	}

/**
*Outputs a skin preview image for use in the skin selection interface. If the preview image does not exists a message indicating so will be displayed instead.
*
*@access private
*@return void
*@param string $skin The name of the directory containing the skin preview image
*
*/
function Skins_PreviewImage ($skin)
	{
	$screen=DIR_SKINS.$skin."/screenshot.jpg";
	if(!file_exists(DIR_SKINS.$skin."/screenshot.jpg")){echo "<i>".LANG_105."</i>\n";}
	else{$size=getImageSize($screen);echo "<img src=\"$screen\" ".$size[3]." border=1>\n";}
	}

/**
*Returns a count of all skins defined within the application
*
*@access private
*@return integer
*
*/
function Skins_Count ()
	{
	$count=0;
	if ($handle = opendir(DIR_SKINS))
		{
		while (false !== ($file = readdir($handle))){if ($file != "." && $file != ".."){$count++;}}
		closedir($handle);
		}
	else {$count="error";}
	return $count;
	}

/**
*Returns a boolean value indicating if a user account is the owner of a document. Returns true if the user account is the owner, false otherwise
*
*@access private
*@return boolean
*@param integer $uid The document owners user id
*@param integer $docid The record id of the document
*
*/
function Docs_IsOwner ($uid,$docid)
	{
	$result=$this->DB_Query("select added_user from ".TABLE_DOCS." where id='".$docid."' limit 1");
	$owner=$this->DB_Result($result,0,"added_user");
	$this->DB_FreeResult($result);
	$group_id=$this->Users_GetUserGroup($uid);
	if($group_id=='1'){return true;}
	else
		{
		if($owner==$uid || $uid=='1'){return true;}
		else{return false;}
		}
	}

/**
*Displays the document management interface
*
*@access private
*@return void
*
*/
function Docs_Manager ()
	{
	$auth=$this->Groups_GetGroupAuth($this->Users_GetUserGroup($this->Session_GetLoginId()));
	if($auth['allow_docs']==0){$this->Error_CriticalStop (ERROR_TERMINATION);}
	echo "<br />";
	$this->UI_OpenWidget(LANG_106);
	echo "<br />";
	$this->UI_OpenTable();
	$result=$this->DB_Query("select * from ".TABLE_DOCS." where parent_id='0' order by nav_order");
	echo "<tr>\n";
	echo "<td align=center class=TableHeader>".$this->UI_Label(LANG_107)."</td>\n";
	echo "<td align=center class=TableHeader>".$this->UI_Label(LANG_108)."</td>\n";
	echo "<td align=center class=TableHeader>".$this->UI_Label(LANG_109)."</td>\n";
	echo "<td align=center class=TableHeader>".$this->UI_Label(LANG_110)."</td>\n";
	$this->UI_OpenForm("",$_SERVER['PHP_SELF']."?cmd=".DOCS_CREATE,"");
	echo "<td align=center class=TableHeader colspan=2>".$this->UI_Submit(LANG_111)."</td>";
	$this->UI_CloseForm ();
	echo "</tr>\n";
	$row=0;
	for($i=0;$i<$this->DB_CountResult($result);$i++)
		{
		if($row==0){$class="TableRow1";}else{$class="TableRow2";}
		echo "<tr>";
		echo "<td class=\"".$class."\">".$this->DB_Result($result,$i,"link_text"). "</td>";
		$active=$this->DB_Result($result,$i,"is_active");
		if($active==1){echo "<td align=center class=\"".$class."\">Yes</td>";}
		else{echo "<td align=center class=\"".$class."\">No</td>";}
		echo "<td align=center class=\"".$class."\">".date(DATE_FORMAT,$this->DB_Result($result,$i,"added_date")). "</td>";
		echo "<td align=center class=\"".$class."\">".date(DATE_FORMAT,$this->DB_Result($result,$i,"modified_date")). "</td>";

		if($this->Docs_IsOwner($this->Session_GetLoginId(),$this->DB_Result($result,$i,"id")))
			{
			$this->UI_OpenForm("",$_SERVER['PHP_SELF']."?cmd=".DOCS_EDIT."&id=".$this->DB_Result($result,$i,"id"),"");
			echo "<td align=center class=\"".$class."\">".$this->UI_Submit(LANG_112)."</td>";
			$this->UI_CloseForm ();
			}
		else{echo "<td align=center class=\"".$class."\">".$this->UI_Label("-")."</td>";}

		if($this->Docs_IsOwner($this->Session_GetLoginId(),$this->DB_Result($result,$i,"id")))
			{
			if($this->DB_Result($result,$i,"id")==1)
				{echo "<td align=center class=\"".$class."\">".$this->UI_Label("X")."</td>";}
			else
				{
				$this->UI_OpenForm("",$_SERVER['PHP_SELF']."?cmd=".DOCS_DELETE."&id=".$this->DB_Result($result,$i,"id"),"return Docs_ConfirmDelete ()");
				echo "<td align=center class=\"".$class."\">".$this->UI_Submit(LANG_113)."</td>";
				$this->UI_CloseForm ();
				}
			}
		else{echo "<td align=center class=\"".$class."\">".$this->UI_Label("-")."</td>";}

		echo "</tr>";
		if($row==0){$row=1;}else{$row=0;}
		$this->Docs_ManagerRecurse($this->DB_Result($result,$i,"id"),$row);
		}
	$this->DB_FreeResult($result);
	echo "</table>\n";
	echo "<br />";
	$this->UI_CloseWidget();
	}

/**
*Enables the document management interface to recursively display the site document structure
*
*@access private
*@return void
*@param integer $id The parent record id of the document for the starting point of the recursion
*@param integer $row Current row number for use with table row styles
*@param integer $indent Optional value indicating the current indice used in recursion
*@see Docs_Manager ()
*
*/
function Docs_ManagerRecurse ($id,$row,$indent=0)
	{
	if($this->Docs_HasSubDocuments ($id))
		{
		$indent++;
		$links=$this->Docs_GetSubDocuments ($id);
		for($i=0;$i<count($links);$i++)
			{
			if($row==0){$class="TableRow1";}else{$class="TableRow2";}
			echo "<tr><td align=center class=\"".$class."\">";
			echo "<img src=\"images/tree.gif\" height=1 width=\"".($indent * 20)."\">";
			echo $this->Docs_GetLinkText ($links[$i]). "</td>";
			$active=$this->Docs_GetActiveStatus ($links[$i]);
			if($active==1){echo "<td align=center class=\"".$class."\">Yes</td>";}
			else{echo "<td align=center class=\"".$class."\">No</td>";}
			echo "<td align=center class=\"".$class."\">".$this->Docs_GetAddedDate ($links[$i]). "</td>";
			echo "<td align=center class=\"".$class."\">".$this->Docs_GetModifiedDate ($links[$i]). "</td>";
			if($this->Docs_IsOwner($this->Session_GetLoginId(),$links[$i]))
				{
				$this->UI_OpenForm("",$_SERVER['PHP_SELF']."?cmd=".DOCS_EDIT."&id=".$links[$i],"");
				echo "<td align=center class=\"".$class."\">".$this->UI_Submit(LANG_112)."</td>";
				$this->UI_CloseForm ();
				}
			else{echo "<td align=center class=\"".$class."\">".$this->UI_Label("-")."</td>";}
			if($this->Docs_IsOwner($this->Session_GetLoginId(),$links[$i]))
				{
				$this->UI_OpenForm("",$_SERVER['PHP_SELF']."?cmd=".DOCS_DELETE."&id=".$links[$i],"return Docs_ConfirmDelete ()");
				echo "<td align=center class=\"".$class."\">".$this->UI_Submit(LANG_113)."</td>";
				$this->UI_CloseForm ();
				}
			else{echo "<td align=center class=\"".$class."\">".$this->UI_Label("-")."</td>";}
			echo "</tr>";
			if($row==0){$row=1;}else{$row=0;}
			$this->Docs_ManagerRecurse($links[$i],$row,$indent);
			}
		$indent--;
		}
	}

/**
*Displays the document form in one of two states add or edit mode
*
*@access private
*@return void
*@param integer $mode	Value indicating whether to output the form in add (0) or edit (1) mode
*@param integer $id			Optional record id of the record to use when in edit mode (1), in add (0) mode will default to nothing
*
*/
function Docs_Form ($mode,$id='')
	{
	$auth=$this->Groups_GetGroupAuth($this->Users_GetUserGroup($this->Session_GetLoginId()));
	if($auth['allow_docs']==0){$this->Error_CriticalStop (ERROR_TERMINATION);}
	if($mode==1)
		{
		$result=$this->DB_Query("select * from ".TABLE_DOCS." where id='".$id."' limit 1");
		$added=date(DATE_FORMAT,$this->DB_Result($result,0,"added_date"));
		$added_user=$this->DB_Result($result,0,"added_user");
		$modified=date(DATE_FORMAT,$this->DB_Result($result,0,"modified_date"));
		$modified_user=$this->DB_Result($result,0,"modified_user");
		$is_active=$this->DB_Result($result,0,"is_active");
		$parent_id=$this->DB_Result($result,0,"parent_id");
		$link_text=$this->DB_Result($result,0,"link_text");
		$meta_title=$this->DB_Result($result,0,"meta_title");
		$meta_keywords=$this->DB_Result($result,0,"meta_keywords");
		$meta_description=$this->DB_Result($result,0,"meta_description");
		$content=$this->DB_Result($result,0,"content");
		$module=$this->DB_Result($result,0,"module");
		$this->DB_FreeResult($result);
		$this->UI_OpenForm("docsForm",$_SERVER['PHP_SELF']."?cmd=".DOCS_UPDATE."&id=".$id,"return Docs_Form()");
		$this->UI_OpenWidget(LANG_114);
		}
	elseif($mode==0)
		{
		$added=strtotime(date(DATE_FORMAT));
		$is_active=1;$parent_id=0;$link_text="";$meta_title="";
		$meta_keywords="";$meta_description="";$content="";$module="";
		$this->UI_OpenForm("docsForm",$_SERVER['PHP_SELF']."?cmd=".DOCS_ADD,"return Docs_Form()");
		$this->UI_OpenWidget(LANG_115);
		}
	$this->UI_OpenTable ();
	echo "<tr><td>";
	$this->UI_OpenTable (300);
	echo "<tr><td>".$this->UI_Label(LANG_116)."<br />".$this->UI_TextBox("link_text",$link_text,30)."</td></tr>";
	echo "<tr><td>".$this->UI_Label(LANG_117)."<br />";
	$this->UI_OpenListBox("is_active",1);
	echo $this->UI_ListOption($is_active,($is_active==1)?LANG_118:LANG_119,1);
	echo $this->UI_ListOption("1",LANG_118,0);
	echo $this->UI_ListOption("0",LANG_119,0);
	$this->UI_CloseListBox();
	echo "</td></tr>";
	echo "<tr><td>".$this->UI_Label(LANG_120)."<br />";
	$this->UI_OpenListBox("parent_id",1);
	if($parent_id==0){echo $this->UI_ListOption($parent_id,LANG_121,1);}
	else
		{
		echo $this->UI_ListOption($parent_id,$this->Docs_GetLinkText($parent_id),1);
		echo $this->UI_ListOption("0",LANG_121,0);
		}
	if($mode==1){$this->Docs_ListBox($id);}
	else{$this->Docs_ListBox();}
	$this->UI_CloseListBox();
	echo "</td></tr>";
	echo "<tr><td>".$this->UI_Label(LANG_122)."<br />";
	$this->UI_OpenListBox("module",1);
	if(empty($module)){echo $this->UI_ListOption("",LANG_123,1);}
	else
		{
		echo $this->UI_ListOption($module,$module,1);
		echo $this->UI_ListOption("",LANG_123,0);
		}
	$this->Mod_ListBox();
	$this->UI_CloseListBox();
	echo "</td></tr>";
	$this->UI_CloseTable ();
	echo "</td><td>";
	$this->UI_OpenTable (300);
	echo "<tr><td>".$this->UI_Label(LANG_124)."<br />".$this->UI_TextBox("meta_title",$meta_title,30)."</td></tr>";
	echo "<tr><td>".$this->UI_Label(LANG_125)."<br />".$this->UI_TextArea("meta_keywords",$meta_keywords,3,40)."</td></tr>";
	echo "<tr><td>".$this->UI_Label(LANG_126)."<br />".$this->UI_TextArea("meta_description",$meta_description,3,40)."</td></tr>";
	$this->UI_CloseTable ();
	echo "</tr></td>";
	echo "<tr><td colspan=2>";
	$this->UI_WYSIWYG_Editor ($content,15,60);
	echo "</td></tr>";
	$this->UI_CloseTable ();
	if($mode==1){echo $this->UI_Submit(LANG_127);}
	elseif($mode==0){echo $this->UI_Submit(LANG_128);}
	$this->UI_CloseWidget();
	$this->UI_CloseForm();
	}

/**
*Adds a document to the database
*
*@access private
*@return void
*
*/
function Docs_Add ()
	{
	$auth=$this->Groups_GetGroupAuth($this->Users_GetUserGroup($this->Session_GetLoginId()));
	if($auth['allow_docs']==0){$this->Error_CriticalStop (ERROR_TERMINATION);}
	$added = strtotime(date(DATE_FORMAT));
	$parent_id=$_REQUEST['parent_id'];
	$is_active=$_REQUEST['is_active'];
	$user=$this->Session_GetLoginID ();
	$link_text=$this->DB_ParseInput($_REQUEST['link_text']);
	$meta_title=$this->DB_ParseInput($_REQUEST['meta_title']);
	$meta_keywords=$this->DB_ParseInput($_REQUEST['meta_keywords']);
	$meta_description=$this->DB_ParseInput($_REQUEST['meta_description']);
	$content=$_REQUEST['content'];
	$module=$_REQUEST['module'];
	$order=$this->DocsOrder_GetNextOrder ();
	$this->DB_Query("insert into ".TABLE_DOCS." (added_date,added_user,modified_date,modified_user,parent_id,is_active,nav_order,link_text,meta_title,meta_keywords,meta_description,content,module) values ('".$added."','".$user."','".$added."','".$user."','".$parent_id."','".$is_active."','".$order."','".$link_text."','".$meta_title."','".$meta_keywords."','".$meta_description."','".$content."','".$module."')");
	$this->UI_Message(LANG_129);
	$this->UI_Navigate($_SERVER['PHP_SELF']."?cmd=".DOCS_MANAGE);
	}

/**
*Updates changes made to a document
*
*@access private
*@return void
*@param integer $id The record id of the user group
*
*/
function Docs_Update ($id)
	{
	$auth=$this->Groups_GetGroupAuth($this->Users_GetUserGroup($this->Session_GetLoginId()));
	if($auth['allow_docs']==0){$this->Error_CriticalStop (ERROR_TERMINATION);}
	$modified = strtotime(date(DATE_FORMAT));
	$parent_id=$_REQUEST['parent_id'];
	$is_active=$_REQUEST['is_active'];
	$user=$this->Session_GetLoginID ();
	$link_text=$this->DB_ParseInput($_REQUEST['link_text']);
	$meta_title=$this->DB_ParseInput($_REQUEST['meta_title']);
	$meta_keywords=$this->DB_ParseInput($_REQUEST['meta_keywords']);
	$meta_description=$this->DB_ParseInput($_REQUEST['meta_description']);
	$content=$_REQUEST['content'];
	$module=$_REQUEST['module'];
	$this->DB_Query("update ".TABLE_DOCS." set  modified_date='".$modified."',modified_user='".$user."',parent_id='".$parent_id."',is_active='".$is_active."',link_text='".$link_text."',meta_title='".$meta_title."',meta_keywords='".$meta_keywords."',meta_description='".$meta_description."',content='".$content."',module='".$module."' where id='".$id."' limit 1");
	$this->UI_Message(LANG_130);
	$this->UI_Navigate($_SERVER['PHP_SELF']."?cmd=".DOCS_MANAGE);
	}

/**
*Deletes a document from the database. Each request for deletion will first check if a given document has sub documents defined beneath it and if so will cancel the deletion.
*
*@access private
*@return void
*@param integer $id Record id of the user account to be deleted
*
*/
function Docs_Delete ($id)
	{
	$auth=$this->Groups_GetGroupAuth($this->Users_GetUserGroup($this->Session_GetLoginId()));
	if($auth['allow_docs']==0){$this->Error_CriticalStop (ERROR_TERMINATION);}
	if($this->Docs_HasSubDocuments ($id))
		{
		$this->UI_Message(LANG_131);
		$this->UI_Navigate($_SERVER['PHP_SELF']."?cmd=".DOCS_MANAGE);
		}
	else
		{
		$result=$this->DB_Query("delete from ".TABLE_DOCS." where id='".$id."' limit 1");
		$this->UI_Message(LANG_132);
		$this->UI_Navigate($_SERVER['PHP_SELF']."?cmd=".DOCS_MANAGE);
		}
	}

/**
*Returns the link text for a requested document
*
*@access private
*@return string
*@param integer $id The record id of the document
*
*/
function Docs_GetLinkText ($id)
	{
	$result=$this->DB_Query("select link_text from ".TABLE_DOCS." where id='".$id."' limit 1");
	$link=$this->DB_Result($result,0,"link_text");
	$this->DB_FreeResult($result);
	return $link;
	}

/**
*Returns a formatted version of the date added timestamp for a requested document
*
*@access private
*@return string
*@param integer $id The record id of the document
*
*/
function Docs_GetAddedDate ($id)
	{
	$result=$this->DB_Query("select added_date from ".TABLE_DOCS." where id='".$id."' limit 1");
	$date=$this->DB_Result($result,0,"added_date");
	$this->DB_FreeResult($result);
	return date(DATE_FORMAT,$date);
	}

/**
*Returns a formatted version of the date modified timestamp for a requested document
*
*@access private
*@return string
*@param integer $id The record id of the document
*
*/
function Docs_GetModifiedDate ($id)
	{
	$result=$this->DB_Query("select modified_date from ".TABLE_DOCS." where id='".$id."' limit 1");
	$date=$this->DB_Result($result,0,"modified_date");
	$this->DB_FreeResult($result);
	return date(DATE_FORMAT,$date);
	}

/**
*Returns a boolean value indicating if a documents status is set to active (true) or inactive (false)
*
*@access private
*@return boolean
*@param integer $id The record id of the document
*
*/
function Docs_GetActiveStatus ($id)
	{
	$result=$this->DB_Query("select is_active from ".TABLE_DOCS." where id='".$id."' limit 1");
	$active=$this->DB_Result($result,0,"is_active");
	$this->DB_FreeResult($result);
	if($active==1){return true;}
	else{return false;}
	}

/**
*Outputs a series of HTML option tags containg user document ids and link text
*
*@access private
*@return void
*@param integer $exclusion Id of a document to keep as hidden from the list box
*/
function Docs_ListBox ($exclusion='')
	{
	$result=$this->DB_Query("select id,link_text from ".TABLE_DOCS." order by link_text");
	$count=$this->DB_CountResult($result);
	for($i=0;$i<$count;$i++)
		{
		$id=$this->DB_Result($result,$i,"id");
		if($id != $exclusion){echo $this->UI_ListOption($id,$this->DB_Result($result,$i,"link_text"));}
		}
	$this->DB_FreeResult($result);
	}

/**
*Returns a count of all documents defined within the application
*
*@access private
*@return integer
*
*/
function Docs_Count ()
	{
	$result=$this->DB_Query("select id from ".TABLE_DOCS);
	$count=$this->DB_CountResult($result);
	$this->DB_FreeResult($result);
	return $count;
	}

/**
*Returns a boolean value indicating if a document has sub documents defined beneath it. Returns true if sub documents exist, false otherwise
*
*@access private
*@return boolean
*@param integer $id The record id of the document
*
*/
function Docs_HasSubDocuments ($id)
	{
	$result=$this->DB_Query("select id from ".TABLE_DOCS." where parent_id='".$id."' limit 1");
	$count=$this->DB_CountResult($result);
	$this->DB_FreeResult($result);
	if($count>0){return true;}
	else{return false;}
	}

/**
*Returns an array of document ids that are sub documents of a parent document
*
*@access private
*@return array
*@param integer $id The record id of the parent document
*
*/
function Docs_GetSubDocuments ($id)
	{
	$links=Array ();
	$result=$this->DB_Query("select * from ".TABLE_DOCS." where parent_id='".$id."' order by nav_order");
	$count=$this->DB_CountResult($result);
	for($i=0;$i<$count;$i++){array_push($links,$this->DB_Result($result,$i,"id"));}
	$this->DB_FreeResult($result);
	return $links;
	}

/**
*Displays the document ordering interface
*
*@access private
*@return void
*
*/
function DocsOrder_Manager ()
	{
	$auth=$this->Groups_GetGroupAuth($this->Users_GetUserGroup($this->Session_GetLoginId()));
	if($auth['allow_order']==0){$this->Error_CriticalStop (ERROR_TERMINATION);}
	$result=$this->DB_Query("select * from ".TABLE_DOCS." where parent_id='0' order by nav_order");
	$this->UI_OpenForm("orderForm",$_SERVER['PHP_SELF']."?cmd=".ORDER_UPDATE,"return Order_Form()");
	$this->UI_OpenWidget(LANG_133);
	echo "<br />";
	$this->UI_OpenTable();
	$row=0;
	for($i=0;$i<$this->DB_CountResult($result);$i++)
		{
		if($row==0){$class="TableRow1";}else{$class="TableRow2";}
		echo "<tr>\n";
		echo "<td class=\"".$class."\">".$this->UI_TextBox("DOC_".$this->DB_Result($result,$i,"id"),$i,3)."&nbsp;\n";
		echo $this->UI_Label($this->DB_Result($result,$i,"link_text"))."</td>\n";
		echo "</tr>\n";
		if($this->Docs_HasSubDocuments($this->DB_Result($result,$i,"id")))
			{$this->DocsOrder_Recurse($this->DB_Result($result,$i,"id"),$row);}
		if($row==0){$row=1;}else{$row=0;}
		}
	$this->UI_CloseTable();
	echo $this->UI_Submit(LANG_134);
	$this->UI_CloseWidget();
	$this->UI_CloseForm ();
	$this->DB_FreeResult($result);
	}

/**
*Enables the document ordering interface to recursively display the site document structure
*
*@access private
*@return void
*@param integer $id The parent record id of the document for the starting point of the recursion
*@param integer $row Current row number for use with table row styles
*@param integer $indent Optional value indicating the current indice used in recursion
*@see Docs_Manager ()
*
*/
function DocsOrder_Recurse ($id,$row,$indent=0)
	{
	if($this->Docs_HasSubDocuments ($id))
		{
		$indent++;
		$links=$this->Docs_GetSubDocuments ($id);
		for($i=0;$i<count($links);$i++)
			{
 			if($row==0){$class="TableRow1";}else{$class="TableRow2";}
			echo "<tr>\n";
			echo "<td class=\"".$class."\">";
			echo "<img src=\"images/tree.gif\" height=1 width=\"".($indent * 30)."\">";
			echo $this->UI_TextBox("SUB_".$links[$i],$i,3)."&nbsp;\n";
			echo $this->UI_Label($this->Docs_GetLinkText ($links[$i]))."</td>\n";
			echo "</tr>\n";
			if($row==0){$row=1;}else{$row=0;}
			$this->DocsOrder_Recurse($links[$i],$indent);
			}
		$indent--;
		}
	}

/**
*Updates changes made to the document ordering structure
*
*@access private
*@return void
*
*/
function DocsOrder_Update ()
	{
	$auth=$this->Groups_GetGroupAuth($this->Users_GetUserGroup($this->Session_GetLoginId()));
	if($auth['allow_order']==0){$this->Error_CriticalStop (ERROR_TERMINATION);}
	$result=$this->DB_Query("select * from ".TABLE_DOCS." where parent_id='0' order by nav_order");
	for($i=0;$i<$this->DB_CountResult($result);$i++)
		{
		$doc=$this->DB_ParseInput($_REQUEST['DOC_'.$this->DB_Result($result,$i,"id")]);
		$this->DB_Query("update ".TABLE_DOCS." set nav_order='".$doc."' where id='".$this->DB_Result($result,$i,"id")."' ");
		if($this->Docs_HasSubDocuments($this->DB_Result($result,$i,"id")))
			{$this->DocsOrder_UpdateRecurse ($this->DB_result($result,$i,"id"));}
		}
	$this->UI_Message(LANG_135);
	$this->UI_Navigate($_SERVER['PHP_SELF']."?cmd=".ORDER_MANAGE);
	}

/**
*Enables the document ordering update to recursively update the site document structure
*
*@access private
*@return void
*@param integer $id The parent record id of the document for the starting point of the recursion
*@param integer $indent Optional value indicating the current indice used in recursion
*@see DocsOrder_Update ()
*
*/
function DocsOrder_UpdateRecurse ($id,$indent=0)
	{
	$result=$this->DB_Query("select * from ".TABLE_DOCS." where parent_id='".$id."' ");
	for($j=0;$j<$this->DB_CountResult($result);$j++)
		{
		$sub=$this->DB_ParseInput($_REQUEST['SUB_'.$this->DB_Result($result,$j,"id")]);
		$this->DB_Query("update ".TABLE_DOCS." set nav_order='".$sub."' where id='".$this->DB_Result($result,$j,"id")."' ");
		$this->DocsOrder_UpdateRecurse ($this->DB_Result($result,$j,"id"));
		}
	$this->DB_FreeResult($result);
	}

/**
*Returns the next available document ordering number for use when creating a new document
*
*@access private
*@return integer
*
*/
function DocsOrder_GetNextOrder ()
	{$count=$this->Docs_Count ();$count++;return $count;}

/**
*Displays the file management interface
*
*@access private
*@return void
*
*/
function Files_Manager ()
	{
	$auth=$this->Groups_GetGroupAuth($this->Users_GetUserGroup($this->Session_GetLoginId()));
	if($auth['allow_files']==0){$this->Error_CriticalStop (ERROR_TERMINATION);}
	$this->UI_OpenForm("fileForm",$_SERVER['PHP_SELF']."?cmd=".FILES_DELETE,"return Files_ConfirmDelete ()");
	$this->UI_OpenWidget(LANG_136);
	echo $this->UI_Label(LANG_137)."<br />";
	$this->UI_OpenListBox("file",8);
	$this->Files_ListBox ();
	$this->UI_CloseListBox ();
	echo "<br /><br />".$this->UI_Submit(LANG_138);
	$this->UI_CloseWidget();
	$this->UI_CloseForm();
	}

/**
*Displays the file upload interface for use with the file management interface
*
*@access private
*@return void
*
*/
function Files_UploadForm ()
	{
	$auth=$this->Groups_GetGroupAuth($this->Users_GetUserGroup($this->Session_GetLoginId()));
	if($auth['allow_files']==0){$this->Error_CriticalStop (ERROR_TERMINATION);}
	$this->UI_OpenFileForm("uploadForm",$_SERVER['PHP_SELF']."?cmd=".FILES_UPLOAD,"return Files_UploadForm()");
	$this->UI_OpenWidget(LANG_139);
	echo $this->UI_FileBox("userfile","",40)."<br /><br />";
	echo $this->UI_Label(LANG_140)." ";
	$this->UI_OpenListBox ("useIR",1);
	echo $this->UI_ListOption("0",LANG_142,1);
	echo $this->UI_ListOption("1",LANG_141,0);
	$this->UI_CloseListBox ();
	$this->UI_OpenTable(250);
	echo "<tr><td>".$this->UI_Label(LANG_143)."</td><td>".$this->UI_TextBox("resizeH","0",5)."</td></tr>";
	echo "<tr><td>".$this->UI_Label(LANG_144)."</td><td>".$this->UI_TextBox("resizeW","0",5)."</td></tr>";
	$this->UI_CloseTable();
	echo $this->UI_Submit(LANG_145);
	$this->UI_CloseWidget();
	$this->UI_CloseForm();
	}

/**
*Uploads a file to the files directory of the installation. Optionally uses GDLib to resize an image after upload to user specified dimensions.
*
*@access private
*@return void
*
*/
function Files_UploadFile ()
	{
	$auth=$this->Groups_GetGroupAuth($this->Users_GetUserGroup($this->Session_GetLoginId()));
	if($auth['allow_files']==0){$this->Error_CriticalStop (ERROR_TERMINATION);}
	$allowFileTypes=Array("image/gif","image/pjpeg","image/jpeg","image/png","application/pdf","application/msword","application/vnd.ms-excel","application/x-zip-compressed");
	$useIR=$_REQUEST['useIR'];
	$type=$_FILES['userfile']['type'];
	echo $type;
	$match=0;
	for($i=0;$i<count($allowFileTypes);$i++){if($allowFileTypes[$i]==$type){$match=1;}}
	if($match==1)
		{
		$sent=@move_uploaded_file($_FILES['userfile']['tmp_name'], DIR_FILES.$_FILES['userfile']['name']);
		if(!$sent){$this->UI_Message(LANG_146);}
		else
			{
			chmod(DIR_FILES.$_FILES['userfile']['name'],0644);
			$this->UI_Message(LANG_147);
			if(isset($useIR)&&$useIR==1)
				{
				if(!$this->Images_ResizeImage("","",$_FILES['userfile']['name'],$_REQUEST['resizeW'],$_REQUEST['resizeH'],$type))
					{$GUI->$this->UI_Message(LANG_148);	}
				}}}
		else{$this->UI_Message(LANG_149);}
	$this->UI_Navigate($_SERVER['PHP_SELF']."?cmd=".FILES_MANAGE);
	}

/**
*Deletes a specified file from the files directory of the installation
*
*@access private
*@return void
*@param string $filename Filename of the file to be deleted
*
*/
function Files_DeleteFile ($filename)
	{
	$auth=$this->Groups_GetGroupAuth($this->Users_GetUserGroup($this->Session_GetLoginId()));
	if($auth['allow_files']==0){$this->Error_CriticalStop (ERROR_TERMINATION);}
	if(@file_exists(DIR_FILES.$filename)){@unlink(DIR_FILES.$filename);}
	$this->UI_Navigate($_SERVER['PHP_SELF']."?cmd=".FILES_MANAGE);
	}

/**
*Deletes a specified folder and its contents from the files directory of the installation
*
*@access private
*@return void
*@param string $folder Directory name to be deleted
*@todo Implement this method into the file management interface
*/
function Files_DeleteFolder ($folder)
	{
	$auth=$this->Groups_GetGroupAuth($this->Users_GetUserGroup($this->Session_GetLoginId()));
	if($auth['allow_files']==0){$this->Error_CriticalStop (ERROR_TERMINATION);}
	if ($handle = opendir(DIR_FILES.$folder))
		{
		while (false !== ($file = readdir($handle))){if ($file != "." && $file != "..")
			{if(@file_exists(DIR_FILES.$file)){@unlink(DIR_FILES.$file);}}
		}
		closedir($handle);
		}
	mkdir (DIR_FILES.$folder);
	$this->UI_Navigate($_SERVER['PHP_SELF']."?cmd=".FILES_MANAGE);
	}

/**
*Creates a specified folder in the files directory of the installation
*
*@access private
*@return void
*@param string $folder Directory name to be created
*@todo Implement this method into the file management interface
*/
function Files_CreateFolder ($folder)
	{
	$auth=$this->Groups_GetGroupAuth($this->Users_GetUserGroup($this->Session_GetLoginId()));
	if($auth['allow_files']==0){$this->Error_CriticalStop (ERROR_TERMINATION);}
	mkdir (DIR_FILES.$folder, 0700);
	$this->UI_Navigate($_SERVER['PHP_SELF']."?cmd=".FILES_MANAGE);
	}

/**
*Outputs a series of HTML option tags containg filenames
*
*@access private
*@return void
*
*/
function Files_ListBox ()
	{
	if ($handle = opendir(DIR_FILES))
		{
		while (false !== ($file = readdir($handle))){if ($file != "." && $file != ".."){$this->UI_ListOption("$file","$file");}}
		closedir($handle);
		}
	}

/**
*Returns a count of files present in the applications files directory
*
*@access private
*@return integer
*
*/
function Files_Count ()
	{
	$count=0;
	if ($handle = opendir(DIR_FILES))
		{
		while (false !== ($file = readdir($handle))){if ($file != "." && $file != ".."){$count++;}}
		closedir($handle);
		}
	else {$count="error";}
	return $count;
	}

/**
*Enables resizing of an image file using GDLib, a php extension. Returns true on sucess, false otherwise. This method will also check to ensure the required php extensions are availble to resize images using function_exists ()
*
*@access private
*@return boolean
*@param string $image_path Argument is deprecated
*@param string $thumb_path Argument is deprecated
*@param string $image_name The filename of the original image
*@param string $thumb_width The desired new image width in pixels
*@param string $thumb_height The desired new image height in pixels
*@param string $type A string specifying the MIME type of the image to resize (image/jpeg or image/gif)
*@todo Remove deprecated arguments
*
*/
function Images_ResizeImage ($image_path,$thumb_path,$image_name,$thumb_width,$thumb_height,$type)
	{
	if(!function_exists('imagecreatefromjpeg')) {$this->UI_Message("Image Resize NOT Supported");return false;}
	else
		{
		if($type=="image/gif"){$src_img = imagecreatefromgif(DIR_FILES.$image_name);}
		elseif($type=="image/pjpeg"||$type=="image/jpeg"){$src_img = imagecreatefromjpeg(DIR_FILES.$image_name); }
		else{return false;}
		$origw=imagesx($src_img);
		$origh=imagesy($src_img);
		$new_w = $thumb_width;
		$diff=$origw/$new_w;
		$new_h=$thumb_height;
		$dst_img = imagecreate($new_w,$new_h);
		 imagecopyresized($dst_img,$src_img,0,0,0,0,$new_w,$new_h,imagesx($src_img),imagesy($src_img));
		if($type=="image/gif"){imagegif($dst_img, DIR_FILES.$image_name.""); }
		elseif($type=="image/pjpeg"||$type=="image/jpeg"){imagejpeg($dst_img, DIR_FILES.$image_name.""); }
		return true;
		}
	}

/**
*Displays the modules management interface displaying all installed modules within the mods directory of the application. Each module will be individually checked for its installation status through the use of a dependancy file containing arrays of required database table names.
*
*@access private
*@return void
*@todo Implement per module security settings based on current user login (planned for version 6)
*/
function Mod_Manager ()
	{
	$auth=$this->Groups_GetGroupAuth($this->Users_GetUserGroup($this->Session_GetLoginId()));
	if($auth['allow_mods']==0){$this->Error_CriticalStop (ERROR_TERMINATION);}
	echo "<br />";
	if($this->Mod_Count ()<1)
		{
		$this->UI_Message(LANG_150);
		$this->UI_Navigate($_SERVER['PHP_SELF']."?cmd=".INIT);
		}
	else
		{
		$this->UI_OpenWidget(LANG_151);
		if ($handle = opendir(DIR_MODS))
			{
			echo "<br />";
			$this->UI_OpenTable();
			echo "<tr>\n";
			echo "<td class=TableHeader>".$this->UI_Label(LANG_152)."</td>\n";
			echo "<td class=TableHeader>".$this->UI_Label(LANG_153)."</td>\n";
			echo "<td class=TableHeader>&nbsp;</td>\n";
			echo "</tr>\n";
			$row=0;
			while (false !== ($file = readdir($handle)))
				{
				if ($file != "." && $file != "..")
					{
					if($row==0){$class="TableRow1";}else{$class="TableRow2";}
					echo "<tr>\n";
					echo "<td class=\"".$class."\">".$this->UI_Label("$file")."</td>\n";
					if(!file_exists(DIR_MODS.$file."/dependancy.php")){echo "<td class=\"".$class."\">".LANG_154."</td>\n";}
					else
						{
						if(!$this->Mod_IsInstalled($file)) // If module dependancies are NOT installed
							{
							$this->UI_OpenForm("",$_SERVER['PHP_SELF']."?cmd=".MODS_INSTALL."&file=".$file,"return Mods_ConfirmInstall()");
							echo "<td class=\"".$class."\">".$this->UI_Submit(LANG_155)."</td>\n";
							$this->UI_CloseForm ();
							}
						else // module dependancies are OK and present in the database
							{
							include DIR_MODS.$file."/dependancy.php";
							if(count($DependancyTables)<1)
								{
								echo "<td class=\"".$class."\" align=\"center\">X</td>\n";
								}
							else
								{
								$this->UI_OpenForm("",$_SERVER['PHP_SELF']."?cmd=".MODS_UNINSTALL."&file=".$file,"return Mods_ConfirmUnInstall()");
								echo "<td class=\"".$class."\">".$this->UI_Submit(LANG_156)."</td>\n";
								$this->UI_CloseForm ();
								}
							}
						}
					if(!file_exists(DIR_MODS.$file."/admin.php"))
						{echo "<td class=\"".$class."\">".LANG_157."</td>\n";}
					else
						{
						if(!$this->Mod_IsInstalled($file)) // If module dependancies are NOT installed
							{echo "<td class=\"".$class."\">".LANG_158."</td>\n";}
						else // module dependancies are OK and present in the database
							{
							$this->UI_OpenForm("",$_SERVER['PHP_SELF']."?cmd=".MODS_USE."&file=".$file,"");
							echo "<td class=\"".$class."\">".$this->UI_Submit(LANG_159)."</td>\n";
							$this->UI_CloseForm ();
							}
						}
					echo "</tr>\n";
					if($row==0){$row=1;}else{$row=0;}
					}
				}
			$this->UI_CloseTable();
			closedir($handle);
			}
		$this->UI_CloseWidget();
		}
	}

/**
*Outputs a series of HTML option tags containg module names
*
*@access private
*@return void
*
*/
function Mod_ListBox ()
	{
	if ($handle = opendir(DIR_MODS))
		{
		while (false !== ($file = readdir($handle)))
			{
			if ($file != "." && $file != "..")
				{if($this->Mod_IsInstalled ($file)){echo $this->UI_ListOption("$file","$file");}}
			}
		closedir($handle);
		}
	}

/**
*Returns a count of all modules present within the mods directory of the application
*
*@access private
*@return integer
*
*/
function Mod_Count ()
	{
	$count=0;
	if ($handle = opendir(DIR_MODS))
		{
		while (false !== ($file = readdir($handle))){if ($file != "." && $file != ".."){$count++;}}
		closedir($handle);
		}
	else {$count="error";}
	return $count;
	}

/**
*Returns a boolean value indicating if a module has its required database tables installed. Returns true if all dependancies are satisfied, false otherwise. Required database structure is defined in each modules dependancy.php file in the form of an array orf required table names
*
*@access private
*@return boolean
*@param string $file The directory name of a module
*@todo Correct the argument from $file to $dir to make more sense
*
*/
function Mod_IsInstalled ($file)
	{
	include DIR_MODS.$file."/dependancy.php";
	$DependancyTablesOK=true;
	for($i=0;$i<count($DependancyTables);$i++)
		{if(!$this->DB_TableExists($DependancyTables[$i])){$DependancyTablesOK=false;}}
	return $DependancyTablesOK;
	}

/**
*Automates the installation of required database structure for a module. This method will read in the arrays of defined sql statements to be executed to create the necessary database structure for a module from a modules dependancy.php file.
*
*@access private
*@return void
*@param string $file The directory name of a module
*@todo Correct the argument from $file to $dir to make more sense
*
*/
function Mod_Install ($file)
	{
	$auth=$this->Groups_GetGroupAuth($this->Users_GetUserGroup($this->Session_GetLoginId()));
	if($auth['allow_mods']==0){$this->Error_CriticalStop (ERROR_TERMINATION);}
	include DIR_MODS.$file."/dependancy.php";
	for($i=0;$i<count($DependancySql);$i++){$this->DB_Query($DependancySql[$i]);}
	$this->UI_Message(LANG_160);
	$this->UI_Navigate($_SERVER['PHP_SELF']."?cmd=".MODS_MANAGE);
	}

/**
*Automates the REMOVAL of required database structure for a module. This method will read in the array of defined database table structure for a module from a modules dependancy.php file.
*
*@access private
*@return void
*@param string $file The directory name of a module
*@todo Correct the argument from $file to $dir to make more sense
*
*/
function Mod_UnInstall ($file)
	{
	$auth=$this->Groups_GetGroupAuth($this->Users_GetUserGroup($this->Session_GetLoginId()));
	if($auth['allow_mods']==0){$this->Error_CriticalStop (ERROR_TERMINATION);}
	include DIR_MODS.$file."/dependancy.php";
	for($i=0;$i<count($DependancyTables);$i++){$this->DB_Query("drop table ".$DependancyTables[$i]);}
	$this->DB_Query("update ".TABLE_DOCS." set module='' where module='".$file."' ");
	$this->UI_Message(LANG_161);
	$this->UI_Navigate($_SERVER['PHP_SELF']."?cmd=".MODS_MANAGE);
	}

/**
*Includes a modules administrative interface and language translation file, if a matching language translation file is not available for the current language constant then the default US_ENGLISH file will be loaded.
*
*@access private
*@return void
*@param string $file The directory name of a module
*@todo Correct the argument from $file to $dir to make more sense
*
*/
function Mod_Load ($file)
	{
	global $IW;
	$auth=$this->Groups_GetGroupAuth($this->Users_GetUserGroup($this->Session_GetLoginId()));
	if($auth['allow_mods']==0){$this->Error_CriticalStop (ERROR_TERMINATION);}
	if(!file_exists(DIR_MODS.$file."/".IWARE_LANGUAGE)){include DIR_MODS.$file."/US_ENGLISH";}
	else{include DIR_MODS.$file."/".IWARE_LANGUAGE;}
	include DIR_MODS.$file."/admin.php";
	}

/**
*Returns a document META title data
*
*@access public
*@return string
*@param integer $id The record id of a document
*
*/
function Client_GetPageTitle ($id)
	{
	$result=$this->DB_Query("select meta_title from ".TABLE_DOCS." where id='".$id."' limit 1");
	$data=$this->DB_Result($result,0,"meta_title");
	$this->DB_FreeResult($result);
	return $data;
	}

/**
*Returns a document META keyword data
*
*@access public
*@return string
*@param integer $id The record id of a document
*
*/
function Client_GetPageKeywords ($id)
	{
	$result=$this->DB_Query("select meta_keywords from ".TABLE_DOCS." where id='".$id."' limit 1");
	$data=$this->DB_Result($result,0,"meta_keywords");
	$this->DB_FreeResult($result);
	return $data;
	}

/**
*Returns a document META description data
*
*@access public
*@return string
*@param integer $id The record id of a document
*
*/
function Client_GetPageDescription ($id)
	{
	$result=$this->DB_Query("select meta_description from ".TABLE_DOCS." where id='".$id."' limit 1");
	$data=$this->DB_Result($result,0,"meta_description");
	$this->DB_FreeResult($result);
	return $data;
	}

/**
*Returns the site header data
*
*@access public
*@return string
*
*/
function Client_GetHeader ()
	{
	$result=$this->DB_Query("select use_header,header from ".TABLE_LAYOUT." limit 1");
	$use=$this->DB_Result($result,0,"use_header");
	$data=$this->DB_Result($result,0,"header");
	$this->DB_FreeResult($result);
	if($use!=1){$data="";}
	return $data;
	}

/**
*Returns the name of the currently active skin
*
*@access public
*@return string
*
*/
function Client_GetSkin ()
	{
	$result=$this->DB_Query("select skin from ".TABLE_LAYOUT." limit 1");
	$data=$this->DB_Result($result,0,"skin");
	$this->DB_FreeResult($result);
	return $data;
	}

/**
*Returns a documents contents
*
*@access public
*@return string
*@param integer $id The record id of a document
*
*/
function Client_GetContent ($id)
	{
	$result=$this->DB_Query("select content from ".TABLE_DOCS." where id='".$id."' limit 1");
	if($this->DB_CountResult($result)<1){$data='';}
	else{$data=$this->DB_Result($result,0,"content");}
	$this->DB_FreeResult($result);
	return $data;
	}

/**
*Includes a documents defined module if present and also any client side language translations
*
*@access public
*@return void
*@param integer $id The record id of a document
*
*/
function Client_GetModule ($id)
	{
	$result=$this->DB_Query("select module from ".TABLE_DOCS." where id='".$id."' limit 1");
	$data=$this->DB_Result($result,0,"module");
	$this->DB_FreeResult($result);
	if(!empty($data))
		{
		if(!file_exists("admin/".DIR_MODS.$data."/".IWARE_LANGUAGE))
			{include "admin/".DIR_MODS.$data."/US_ENGLISH";}
		else
			{include "admin/".DIR_MODS.$data."/".IWARE_LANGUAGE;}
		include "admin/".DIR_MODS.$data."/module.php";
		}
	}

/**
*Returns the site footer content
*
*@access public
*@return string
*
*/
function Client_GetFooter ()
	{
	$result=$this->DB_Query("select use_footer,footer from ".TABLE_LAYOUT." limit 1");
	$use=$this->DB_Result($result,0,"use_footer");
	$data=$this->DB_Result($result,0,"footer");
	$this->DB_FreeResult($result);
	if($use!=1){$data="";}
	return $data;
	}

/**
*Logs a visitors data for web statistics
*
*@access public
*@return void
*
*/
function Client_LogStats ()
	{
	if($this->DB_TableExists (TABLE_PREFIX."mod_stats"))
		{
		$date_logged=strtotime(date('m/d/Y'));
		$time_logged=strtotime(date('h:i:s'));
		$ip=$_SERVER['REMOTE_ADDR'];
		$browser=$_SERVER['HTTP_USER_AGENT'];
		$referrer = getenv("HTTP_REFERER");
		$sql="insert into ".TABLE_PREFIX."mod_stats (date_logged,time_logged,ip,browser,referrer) values (";
		$sql.="'".$date_logged."',";
		$sql.="'".$time_logged."',";
		$sql.="'".$ip."',";
		$sql.="'".$browser."',";
		$sql.="'".$referrer."'";
		$sql.=")";
		$this->DB_Query($sql);
		}
	}

/**
*Logs events to specified log file
*
*@access public
*@return void
*@param integer $log_number The log file number to use. 0,1 target the access log and 2 targets the error log
*@param string $error Any thrown error text, defaults to an empty string
*
*/
function Client_LogSystem ($log_number,$error='')
	{
	if($this->DB_TableExists (TABLE_PREFIX.'mod_syslogs'))
		{
		$date=date(DATE_FORMAT);
		$time=date(TIME_FORMAT);
		$user_id=$this->Session_GetLoginId();
		$username=$this->Users_GetUserName($user_id);
		switch($log_number)
			{
			case 0:
				$log_file = 'logs/access.log';
				$log_entry=$date.','.$time.',LOGOUT,'.$_SERVER['REMOTE_ADDR'].','.$username.','.$user_id.'|';
			break;
			case 1:
				$log_file = 'logs/access.log';
				$log_entry=$date.','.$time.',LOGOUT,'.$_SERVER['REMOTE_ADDR'].','.$username.','.$user_id.'|';
			break;
			case 2:
				$log_file = 'logs/errors.log';
				$log_entry=$date.','.$time.',ERROR,'.$error.'|';
			break;
			}
		if(is_writable($log_file))
			{
			 $fp=fopen($log_file,'a');
			 fwrite($fp,$log_entry);
			 fclose($fp);
			}
		}
	}


/**
*Throws an error message and halts the application
*
*@access private
*@return void
*@param string $ErrorCode The error text to be displayed
*
*/
function Error_CriticalStop ($ErrorCode)
	{
	if(defined('TABLE_PREFIX'))
		{
		if($this->DB_TableExists (TABLE_PREFIX.'mod_syslogs'))
			{$this->Client_LogSystem (2,$ErrorCode);}
		}
	die('');
	exit ();
	}

/**
*Throws a minor error message
*
*@access private
*@return void
*@param string $ErrorCode The error text to be displayed
*
*/
function Error_ThrowError ($ErrorCode)
	{
	if($this->DB_TableExists (TABLE_PREFIX.'mod_syslogs'))
		{$this->Client_LogSystem (2,$ErrorCode);}
	echo $ErrorCode;
	}

/**
*Verifies the required configuration files exist for the application and includes them relative to where they are required
*
*@access private
*@return void
*
*/
function Protect_ConfigExists ()
	{
	if(SITE_VIEW==1)
		{
		if(!file_exists("admin/config.php")){$this->Error_CriticalStop (ERROR_CONFIG);}
		else{include "admin/config.php";}
		}
	else
		{
		if(!file_exists("config.php")){$this->Error_CriticalStop (ERROR_CONFIG);}
		else{include "config.php";}
		}
	}

/**
*Verifies the required language definition files exist for the application and includes them relative to where they are required
*
*@access private
*@return void
*
*/
function Protect_LangExists ()
	{
	if(SITE_VIEW==1)
		{
		if(!file_exists("admin/lang/".IWARE_LANGUAGE)){$this->Error_CriticalStop (ERROR_LANGUAGE);}
		else{include "admin/lang/".IWARE_LANGUAGE;}
		}
	else
		{
		if(!file_exists("lang/".IWARE_LANGUAGE)){$this->Error_CriticalStop (ERROR_LANGUAGE);}
		else{include "lang/".IWARE_LANGUAGE;}
		}
	}

/**
*Verifies permission for application commands have not been tampered with
*
*/
function Protect_Auth (){if(isset($_REQUEST['uid'])){$this->Error_CriticalStop (ERROR_TERMINATION);}}

// end class
}
?>