<?php

	define("MODULE_NAME","EventCalendar_1.0.0");
	define("TABLE_EVENTS",TABLE_PREFIX."mod_eventcalendar");

	class Module  {

		var $startDay = 0;
		var $startMonth = 1;
		var $dayNames = array(MODC_0, MODC_1, MODC_2, MODC_3, MODC_4, MODC_5, MODC_6);
		var $monthNames = array(MODC_7, MODC_8, MODC_9, MODC_10, MODC_11, MODC_12,MODC_13, MODC_14, MODC_15, MODC_16, MODC_17, MODC_18);
		var $daysInMonth = array(31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);	

		/**
		*
		*
		*
		*/
		function getDayNames()
			{return $this->dayNames;}
		
		/**
		*
		*
		*
		*/    
		function setDayNames($names)
			{$this->dayNames = $names;}
		
		/**
		*
		*
		*
		*/    
		function getMonthNames()
			{return $this->monthNames;}
		
		/**
		*
		*
		*
		*/    
		function setMonthNames($names)
			{$this->monthNames = $names;}
		
		/**
		*
		*
		*
		*/    
		function getStartDay()
			{return $this->startDay;}
		
		/**
		*
		*
		*
		*/    
		function setStartDay($day)
			{$this->startDay = $day;}
		
		/**
		*
		*
		*
		*/    
		function getStartMonth()
			{return $this->startMonth;}
		
		/**
		*
		*
		*
		*/    
		function setStartMonth($month)
			{$this->startMonth = $month;}
		
		/**
		*
		*
		*
		*/    
		function getCalendarLink($month, $year)
			{return "?D=".$_REQUEST['D']."&month=".$month."&year=".$year;}
		
		/**
		*
		*
		*
		*/    
		function getDateLink($EventDate)
			{return "?D=".$_REQUEST['D']."&view=1&EventDate=".$EventDate;}
		
		/**
		*
		*
		*
		*/    
		function getCurrentMonthView()
			{
			$d = getdate(time());
			return $this->getMonthView($d["mon"], $d["year"]);
			}
		
		/**
		*
		*
		*
		*/    
		function getCurrentYearView()
			{
			$d = getdate(time());
			return $this->getYearView($d["year"]);
			}

		/**
		*
		*
		*
		*/    
		function getMonthView($month, $year)
			{return $this->getMonthHTML($month, $year);}
		
		/**
		*
		*
		*
		*/    
		function getYearView($year)
			{return $this->getYearHTML($year);}
		
		/**
		*
		*
		*
		*/    
		function getDaysInMonth($month, $year)
			{
			if ($month < 1 || $month > 12)
				{return 0;}
			$d = $this->daysInMonth[$month - 1];
			if ($month == 2)
				{
				if ($year%4 == 0)
					{
					if ($year%100 == 0)
						{
						if ($year%400 == 0)
							{$d = 29;}
						}
					else{$d = 29;}
					}
				}    
			return $d;
			}
		
		/**
		*
		*
		*
		*/    
		function getMonthHTML($m, $y, $showYear = 1)
			{
			global $IW;
			$s = "";
			$a = $this->adjustDate($m, $y);
			$month = $a[0];
			$year = $a[1];        
			$daysInMonth = $this->getDaysInMonth($month, $year);
			$date = getdate(mktime(12, 0, 0, $month, 1, $year));
			$first = $date["wday"];
			$monthName = $this->monthNames[$month - 1];
			$prev = $this->adjustDate($month - 1, $year);
			$next = $this->adjustDate($month + 1, $year);
			if ($showYear == 1)
				{
				$prevMonth = $this->getCalendarLink($prev[0], $prev[1]);
				$nextMonth = $this->getCalendarLink($next[0], $next[1]);
				}
			else
				{
				$prevMonth = "";
				$nextMonth = "";
				} 	
			$header = $monthName . (($showYear > 0) ? " " . $year : "");
			$s .= "<table border=1>\n";
			
			$s .= "<tr>\n";
			$s .= "<td align=\"center\" valign=\"top\">" . (($prevMonth == "") ? "&nbsp;" : "<a href=\"".$prevMonth."\"><<</a>")  . "</td>\n";
			$s .= "<td align=\"center\" valign=\"top\" colspan=\"5\">".$header."</td>\n"; 
			$s .= "<td align=\"center\" valign=\"top\">" . (($nextMonth == "") ? "&nbsp;" : "<a href=\"".$nextMonth."\">>></a>")  . "</td>\n";
			$s .= "</tr>\n";

			$s .= "<tr>\n";
			$s .= "<td align=\"center\" valign=\"top\">" . $this->dayNames[($this->startDay)%7] . "</td>\n";
			$s .= "<td align=\"center\" valign=\"top\">" . $this->dayNames[($this->startDay+1)%7] . "</td>\n";
			$s .= "<td align=\"center\" valign=\"top\">" . $this->dayNames[($this->startDay+2)%7] . "</td>\n";
			$s .= "<td align=\"center\" valign=\"top\">" . $this->dayNames[($this->startDay+3)%7] . "</td>\n";
			$s .= "<td align=\"center\" valign=\"top\">" . $this->dayNames[($this->startDay+4)%7] . "</td>\n";
			$s .= "<td align=\"center\" valign=\"top\">" . $this->dayNames[($this->startDay+5)%7] . "</td>\n";
			$s .= "<td align=\"center\" valign=\"top\">" . $this->dayNames[($this->startDay+6)%7] . "</td>\n";
			$s .= "</tr>\n";

			$d = $this->startDay + 1 - $first;
			while ($d > 1){$d -= 7;}
			$today = getdate(time());
			while ($d <= $daysInMonth)
				{
				$s .= "<tr>\n";       
				for ($i = 0; $i < 7; $i++)
				{
				$class = ($year == $today["year"] && $month == $today["mon"] && $d == $today["mday"]) ? "calendarToday" : "calendar";
				$s .= "<td class=\"$class\" align=\"right\" valign=\"top\" height=30 width=30>";       
				if ($d > 0 && $d <= $daysInMonth)
					{
					// Check for events scheduled for the current day //
					$EventDate=strtotime($m."/".$d."/".$y);
					$result=$IW->DB_Query("select * from ".TABLE_EVENTS." where event_date='".$EventDate."' ");
					$count=$IW->DB_CountResult($result);
					$IW->DB_FreeResult($result);
					if($count>0){$s.="<a href=\"".$this->getDateLink($EventDate)."\">".$d."</a>";}
					else{$s.=$d;}
					}
				else
					{
					$s .= "&nbsp;";
					}
				$s .= "</td>\n";       
				$d++;
				}
				$s .= "</tr>\n";    
			}
			$s .= "</table>\n";
			return $s;  	
		}
		
		/**
		*
		*
		*
		*/    
		function getYearHTML($year)
			{
			$s = "";
			$prev = $this->getCalendarLink(0, $year - 1);
			$next = $this->getCalendarLink(0, $year + 1);
			$s .= "<table border=1>\n";
			
			$s .= "<tr>";
			$s .= "<td align=\"center\" valign=\"top\" align=\"left\">" . (($prev == "") ? "&nbsp;" : "<a href=\"".$prev."\">&lt;&lt;</a>")  . "</td>\n";
			$s .= "<td valign=\"top\" align=\"center\">" . (($this->startMonth > 1) ? $year . " - " . ($year + 1) : $year) ."</td>\n";
			$s .= "<td align=\"center\" valign=\"top\" align=\"right\">" . (($next == "") ? "&nbsp;" : "<a href=\"".$next."\">&gt;&gt;</a>")  . "</td>\n";
			$s .= "</tr>\n";

			$s .= "<tr>";
			$s .= "<td valign=\"top\">" . $this->getMonthHTML(0 + $this->startMonth, $year, 0) ."</td>\n";
			$s .= "<td valign=\"top\">" . $this->getMonthHTML(1 + $this->startMonth, $year, 0) ."</td>\n";
			$s .= "<td valign=\"top\">" . $this->getMonthHTML(2 + $this->startMonth, $year, 0) ."</td>\n";
			$s .= "</tr>\n";
			$s .= "<tr>\n";
			$s .= "<td valign=\"top\">" . $this->getMonthHTML(3 + $this->startMonth, $year, 0) ."</td>\n";
			$s .= "<td valign=\"top\">" . $this->getMonthHTML(4 + $this->startMonth, $year, 0) ."</td>\n";
			$s .= "<td valign=\"top\">" . $this->getMonthHTML(5 + $this->startMonth, $year, 0) ."</td>\n";
			$s .= "</tr>\n";
			$s .= "<tr>\n";
			$s .= "<td valign=\"top\">" . $this->getMonthHTML(6 + $this->startMonth, $year, 0) ."</td>\n";
			$s .= "<td valign=\"top\">" . $this->getMonthHTML(7 + $this->startMonth, $year, 0) ."</td>\n";
			$s .= "<td valign=\"top\">" . $this->getMonthHTML(8 + $this->startMonth, $year, 0) ."</td>\n";
			$s .= "</tr>\n";
			$s .= "<tr>\n";
			$s .= "<td valign=\"top\">" . $this->getMonthHTML(9 + $this->startMonth, $year, 0) ."</td>\n";
			$s .= "<td valign=\"top\">" . $this->getMonthHTML(10 + $this->startMonth, $year, 0) ."</td>\n";
			$s .= "<td valign=\"top\">" . $this->getMonthHTML(11 + $this->startMonth, $year, 0) ."</td>\n";
			$s .= "</tr>\n";
			$s .= "</table>\n";
			return $s;
			}
		
		/**
		*
		*
		*
		*/
		function adjustDate($month, $year)
			{
			$a = array();  
			$a[0] = $month;
			$a[1] = $year;        
			while ($a[0] > 12){$a[0] -= 12;$a[1]++;} 
			while ($a[0] <= 0){$a[0] += 12;$a[1]--;}    
			return $a;
			}
		
	
		function DisplayEvents ($EventDate)
			{
			global $IW;
			$result=$IW->DB_Query("select * from ".TABLE_EVENTS." where event_date='".$EventDate."' order by event_time desc");
			for($i=0;$i<$IW->DB_CountResult($result);$i++)
				{
				echo "<p>";
				echo date(DATE_FORMAT,$IW->DB_Result($result,$i,"event_date"))." ";
				echo date(TIME_FORMAT,$IW->DB_Result($result,$i,"event_time"))." - ";
				echo $IW->DB_Result($result,$i,"event_title")."<br />";
				echo $IW->DB_Result($result,$i,"event_description");
				echo "</p>";
				}
			$IW->DB_FreeResult($result);
			}

	}

	$Mod = new Module ();
	$d = getdate(time());
	if(!isset($_REQUEST['month'])){$_REQUEST['month']=$d["mon"];}
	if(!isset($_REQUEST['year'])){$_REQUEST['year']=$d["year"];}
	echo $Mod->getMonthView($_REQUEST['month'],$_REQUEST['year']);
	if(!isset($_REQUEST['view'])){$_REQUEST['view']=0;}	
	if($_REQUEST['view']==1){$Mod->DisplayEvents($_REQUEST['EventDate']);}
?>