<?php

	define("MODULE_NAME","ImageGallery_1.0.0");
	define("TABLE_CATEGORY",TABLE_PREFIX."mod_gallery_category");
	define("TABLE_ITEMS",TABLE_PREFIX."mod_gallery_items");

	class Module  {

		function GetItemCount ($category_id)
			{
			global $IW;
			$result = $IW->DB_Query("select id from ".TABLE_ITEMS." where category_id='".$category_id."' ");
			$count=$IW->DB_CountResult($result);
			$IW->DB_FreeResult($result);
			return $count;
			}

		function GetCategoryCount ($category_id)
			{
			global $IW;
			$result = $IW->DB_Query("select id from ".TABLE_CATEGORY." where parent_id='".$category_id."' ");
			$count=$IW->DB_CountResult($result);
			$IW->DB_FreeResult($result);
			return $count;
			}

		function GetParentId ($id)
			{
			global $IW;
			$result = $IW->DB_Query("select parent_id from ".TABLE_CATEGORY." where id='".$id."' ");
			$parent=$IW->DB_Result($result,0,"parent_id");
			$IW->DB_FreeResult($result);
			return $parent;
			}

		function GetCategoryTitle ($id)
			{
			global $IW;
			$result = $IW->DB_Query("select title from ".TABLE_CATEGORY." where id='".$id."' ");
			$title=$IW->DB_Result($result,0,"title");
			$IW->DB_FreeResult($result);
			return $title;
			}

		function HasParentCategory ($id)
			{
			global $IW;
			$result = $IW->DB_Query("select parent_id from ".TABLE_CATEGORY." where id='".$id."' ");
			if($IW->DB_CountResult($result)<1){return false;}
			$parent=$IW->DB_Result($result,0,"parent_id");
			$IW->DB_FreeResult($result);
			if(empty($parent)){return false;}
			else{return true;}
			}

		function HasChildCategory ($id)
			{
			global $IW;
			$result = $IW->DB_Query("select id from ".TABLE_CATEGORY." where parent_id='".$id."' ");
			if($IW->DB_CountResult($result)<1){return false;}
			$child=$IW->DB_Result($result,0,"id");
			$IW->DB_FreeResult($result);
			if(empty($child)){return false;}
			else{return true;}
			}

		function BuildCategoryNavbar ($category_id)
			{
			global $IW;
			$navbar=Array();
			$ArrayLink=$_SERVER['PHP_SELF']."?D=".$_REQUEST['D']."&cmd=".MODS_USE."&file=".MODULE_NAME."&category=".$category_id;
			array_push($navbar,"<a href=\"".$ArrayLink."\">".$this->GetCategoryTitle ($category_id) ."</a> / ");
			if($this->HasParentCategory ($category_id))
				{
				$id=$this->GetParentId($category_id);	
				$this->BuildCategoryNavbar ($id);
				}
			rsort($navbar); 
			for($i=0;$i<count($navbar);$i++){echo $navbar[$i];}
			}

		function Browse ($category_id="")
			{
			global $IW;
			if(empty($category_id))
				{
				$result = $IW->DB_Query("select * from ".TABLE_CATEGORY." where parent_id is NULL or parent_id='0' order by title");		
				}
			else
				{
				echo "<table>";
				echo "<tr><td><b>";
				$BrowseLink=$_SERVER['PHP_SELF']."?D=".$_REQUEST['D']."&cmd=".MODS_USE."&file=".MODULE_NAME;
				echo "<a href=\"".$BrowseLink."\">".MODC_0."</a> / ";
				$this->BuildCategoryNavbar ($category_id);
				echo "</b></td></tr>";
				echo "</table>";
				$result = $IW->DB_Query("select * from ".TABLE_CATEGORY." where parent_id='".$category_id."' order by title");
				}
			echo "<table>";
			for($i=0;$i<$IW->DB_CountResult($result);$i++)
				{
				$CategoryLinkTitle=$IW->DB_Result($result,$i,"title");
				$CategoryLink=$_SERVER['PHP_SELF']."?D=".$_REQUEST['D']."&cmd=".MODS_USE."&file=".MODULE_NAME;
				$CategoryLink.="&category=".$IW->DB_Result($result,$i,"id");
				$TotalCategories=$this->GetCategoryCount($IW->DB_Result($result,$i,"id"));
				$TotalItems=$this->GetItemCount($IW->DB_Result($result,$i,"id"));
				$TotalCount=($TotalCategories+$TotalItems);		
				echo "<tr><td>";
				echo "<a href=\"".$CategoryLink."\">".$CategoryLinkTitle."</a>"." (".$TotalCount.")<br />";
				echo $IW->DB_Result($result,$i,"description");				
				echo "</td></tr>";
				}
			echo "</table>";
 			$this->DisplayItems ($category_id);
			$IW->DB_FreeResult($result);
			}

		function DisplayItems ($category_id)
			{
			global $IW;		
			$sql="select * from ".TABLE_ITEMS." where category_id='".$category_id."' order by title";
			$result=$IW->DB_Query($sql);
			$matches=$IW->DB_CountResult($result);
			$IW->DB_FreeResult($result);
			if(!isset($_REQUEST['prevoffset'])){$_REQUEST['prevoffset']=0;}
			if(!isset($_REQUEST['offset'])){$_REQUEST['offset']=0;}
			$sql .=" limit ".$_REQUEST['offset'].",10";		
			$result = $IW->DB_Query($sql);
			echo "<table>";
			for($i=0;$i<$IW->DB_CountResult($result);$i++)
				{
				echo "<tr>";
				$filename=$IW->DB_Result($result,$i,"filename");
				if(!file_exists("files/".$filename))
					{echo "<td colspan=2>Error Loading Image : ".DIR_FILES.$filename."</td>";}
				else
					{
					$size=getimagesize("files/".$filename);
					$OriginalWidth=$size[0];
					$OriginalHeight=$size[1];
					$ThumbWidth=($size[0]/2);
					$ThumbHeight=($size[1]/2);
					$ZoomImageLink="javascript:ZoomImage('".$filename."',";
					$ZoomImageLink.="'".($OriginalWidth+10)."','".($OriginalHeight+10)."')";
					echo "<td valign=\"top\" align=\"center\">";
					echo "<a href=\"".$ZoomImageLink."\">";
					echo "<img src=\""."files/".$filename."\" width=\"".$ThumbWidth."\" height=\"".$ThumbHeight."\" border=0>";
					echo "</a><br />Click to enlarge</td>";
					echo "<td valign=\"top\"><b>".$IW->DB_Result($result,$i,"title")."</b></a><br />";
					echo $IW->DB_Result($result,$i,"description");
					echo "</td>";
					}
				echo "</tr>";
				}
			echo "</table>";
			$IW->DB_FreeResult($result);
			echo "<table>";
			echo "<tr>";
			if ($_REQUEST['offset']!=0) 
				{
				$PrevPageAction=$_SERVER['PHP_SELF']."?D=".$_REQUEST['D']."&cmd=".MODS_USE."&file=".MODULE_NAME;
				$PrevPageAction.="&category=".$category_id."&offset=".($_REQUEST['offset']-3);
				$PrevPageButton=MODC_1;
				echo "<td><a href=\"".$PrevPageAction."\">".$PrevPageButton."</a></td>";
				}
			$pages=intval($matches/10);
			if ($matches%10) {$pages++;}
			echo "<td>";
			for ($i=1;$i<=$pages;$i++) 
				{
				$newoffset=10*($i-1);
				$PageNumberLink=$_SERVER['PHP_SELF']."?D=".$_REQUEST['D']."&cmd=".MODS_USE."&file=".MODULE_NAME;
				$PageNumberLink.="&category=".$category_id."&offset=".$newoffset;
				$PageNumberLinkTitle=$i;
				echo "<a href=\"".$PageNumberLink."\">".$PageNumberLinkTitle."</a> \n";
				}
			echo "</td>";
			if (!(($_REQUEST['offset']/10)==$pages) && $pages!=1) 
				{
				$newoffset=$_REQUEST['offset']+10;
				$NextPageAction=$_SERVER['PHP_SELF']."?D=".$_REQUEST['D']."&cmd=".MODS_USE."&file=".MODULE_NAME;
				$NextPageAction.="&category=".$category_id."&offset=".$newoffset;
				$NextPageButton=MODC_2;
				echo "<td><a href=\"".$NextPageAction."\">".$NextPageButton."</a></td>";
				}
			echo "</tr>";
			echo "</table>";
			}

	function OutputZoomScript ()
		{
		echo "<script language=JavaScript>\n";
		echo "function ZoomImage(img,w,h)\n{\n";
		echo "var win = window.open('admin/mods/".MODULE_NAME."/zoom.php?image='+img,'','width='+w+',height='+h+'');\n";
		echo "}\n</script>\n";
		}
	
	}

	$Mod = new Module ();
	$Mod->OutputZoomScript ();
	if(!isset($_REQUEST['category'])){$_REQUEST['category']="";}
	$Mod->Browse ($_REQUEST['category']);
?>