<?php
	
	define("MODULE_NAME","WebStats_1.0.0");

	define("TABLE_STATS",TABLE_PREFIX."mod_stats");

	class ModuleAdmin {

		function GetTotalVisits ()
			{
			global $IW;
			$result=$IW->DB_Query("select id from ".TABLE_STATS);
			$count=$IW->DB_CountResult($result);
			$IW->DB_FreeResult($result);
			return $count;
			}

		function GetTotalUniqueVisits ()
			{
			global $IW;
			$result=$IW->DB_Query("select distinct(ip) from ".TABLE_STATS);
			$count=$IW->DB_CountResult($result);
			$IW->DB_FreeResult($result);
			return $count;
			}

		function GetTotalUniqueBrowsers ()
			{
			global $IW;
			$result=$IW->DB_Query("select distinct(browser) from ".TABLE_STATS);
			$count=$IW->DB_CountResult($result);
			$IW->DB_FreeResult($result);
			return $count;
			}

		function GetTopVisitors ()
			{
			global $IW;
			$Visitors=Array();
			$result=$IW->DB_Query("select ip from ".TABLE_STATS);
			for($i=0;$i<$IW->DB_CountResult($result);$i++)
				{
				if(!in_array($IW->DB_Result($result,$i,"ip"),$Visitors))
					{array_push($Visitors,$IW->DB_Result($result,$i,"ip"));}
				}
			$IW->DB_FreeResult($result);
			$VisitorCounts=Array();
			if(count($Visitors)>10){$top=10;}
			else{$top=count($Visitors);}
			for($i=0;$i<$top;$i++)
				{
				$result=$IW->DB_Query("select id from ".TABLE_STATS." where ip='".$Visitors[$i]."'");
				$count=$IW->DB_CountResult($result);
				$IW->DB_FreeResult($result);
				$VisitorCounts[$Visitors[$i]]=$count."/".$this->GetTotalVisits();
				}
			array_multisort($VisitorCounts,SORT_NUMERIC,SORT_DESC);
			return $VisitorCounts;
			}

		function GetTopBrowsers ()
			{
			global $IW;
			$BrowserTypes=Array();
			$result=$IW->DB_Query("select browser from ".TABLE_STATS);
			for($i=0;$i<$IW->DB_CountResult($result);$i++)
				{
				if(!in_array($IW->DB_Result($result,$i,"browser"),$BrowserTypes))
					{array_push($BrowserTypes,$IW->DB_Result($result,$i,"browser"));}
				}
			$IW->DB_FreeResult($result);
			$BrowserCounts=Array();
			if(count($BrowserTypes)>10){$top=10;}
			else{$top=count($BrowserTypes);}
			for($i=0;$i<$top;$i++)
				{
				$result=$IW->DB_Query("select id from ".TABLE_STATS." where browser='".$BrowserTypes[$i]."'");
				$count=$IW->DB_CountResult($result);
				$IW->DB_FreeResult($result);
				$BrowserCounts[$BrowserTypes[$i]]=$count."/".$this->GetTotalVisits();
				}
			array_multisort($BrowserCounts,SORT_NUMERIC,SORT_DESC);
			return $BrowserCounts;
			}

		function GetTopReferrers ()
			{
			global $IW;
			$Referrers=Array();
			$result=$IW->DB_Query("select referrer from ".TABLE_STATS);
			for($i=0;$i<$IW->DB_CountResult($result);$i++)
				{
				if(!in_array($IW->DB_Result($result,$i,"referrer"),$Referrers))
					{array_push($Referrers,$IW->DB_Result($result,$i,"referrer"));}
				}
			$IW->DB_FreeResult($result);
			$ReferrerCounts=Array();
			if(count($Referrers)>10){$top=10;}
			else{$top=count($Referrers);}
			for($i=0;$i<$top;$i++)
				{
				$result=$IW->DB_Query("select id from ".TABLE_STATS." where referrer='".$Referrers[$i]."'");
				$count=$IW->DB_CountResult($result);
				$IW->DB_FreeResult($result);
				$ReferrerCounts[$Referrers[$i]]=$count."/".$this->GetTotalVisits();
				}
			array_multisort($ReferrerCounts,SORT_NUMERIC,SORT_DESC);
			return $ReferrerCounts;
			}

		function ViewStats ()
			{
			global $IW;

			/* top visitors display*/
			$IW->UI_OpenTable();
			echo "<tr><td class=\"TableHeader\" colspan=2>".$IW->UI_Label(MODA_1)." (".$this->GetTotalUniqueVisits()."  ".MODA_2.")</td></tr>";
			$TopVisitors =  $this->GetTopVisitors ();
			$row=0;
			foreach ($TopVisitors as $k => $v)
				{
				if($row==0){$class="TableRow1";}
				else{$class="TableRow2";}
				echo "<tr><td class=\"".$class."\">".$k."</td><td class=\"".$class."\" width=40>".$v."</td></tr>";
				if($row==0){$row=1;}
				else{$row=0;}
				}
			$IW->UI_CloseTable();

			/* top browsers display*/
			$IW->UI_OpenTable();
			echo "<tr><td class=\"TableHeader\" colspan=2>".$IW->UI_Label(MODA_3)." (".$this->GetTotalUniqueBrowsers()." ".MODA_4.")</td></tr>";
			$TopBrowsers =  $this->GetTopBrowsers ();
			$row=0;
			foreach ($TopBrowsers as $k => $v)
				{
				if($row==0){$class="TableRow1";}
				else{$class="TableRow2";}
				echo "<tr><td class=\"".$class."\">".$k."</td><td class=\"".$class."\" width=40>".$v."</td></tr>";
				if($row==0){$row=1;}
				else{$row=0;}
				}
			$IW->UI_CloseTable();

			/* top referrers display */
			$IW->UI_OpenTable();
			echo "<tr><td class=\"TableHeader\" colspan=2>".$IW->UI_Label(MODA_5)."</td></tr>";
			$TopReferrers =  $this->GetTopReferrers ();
			$row=0;
			foreach ($TopReferrers as $k => $v)
				{
				if($row==0){$class="TableRow1";}
				else{$class="TableRow2";}
				echo "<tr><td class=\"".$class."\"><a href=\"".$k."\" target=\"_blank\">".$k."</a></td><td  class=\"".$class."\" width=40>".$v."</td></tr>";
				if($row==0){$row=1;}
				else{$row=0;}
				}
			$IW->UI_CloseTable();

			/* raw logfile display */
			$sql="select * from ".TABLE_STATS." order by date_logged,time_logged desc";
			$result=$IW->DB_Query($sql);
			$matches=$IW->DB_CountResult($result);
			$IW->DB_FreeResult($result);			
			if(!isset($_REQUEST['prevoffset'])){$_REQUEST['prevoffset']=0;}
			if(!isset($_REQUEST['offset'])){$_REQUEST['offset']=0;}
			$sql .=" limit ".$_REQUEST['offset'].",10";				
			$result=$IW->DB_Query($sql);
			$row=0;
			$IW->UI_OpenTable();

			echo "<tr>";
			echo "<td class=\"TableHeader\" colspan=2>".$IW->UI_Label(MODA_6)."</td>";
			$IW->UI_OpenForm("",$_SERVER['PHP_SELF']."?cmd=".MODS_USE."&file=".MODULE_NAME."&purge=1","");
			echo "<td class=\"TableHeader\" align=\"right\">".$IW->UI_Submit(MODA_7)."</td>";
			$IW->UI_CloseForm();
			echo "</tr>";

			for($i=0;$i<$IW->DB_CountResult($result);$i++)
				{
				if($row==0){$class="TableRow1";}
				else{$class="TableRow2";}
				echo "<tr>";
				echo "<td class=\"".$class."\">".date(DATE_FORMAT,$IW->DB_Result($result,$i,"date_logged"))."</td>";
				echo "<td class=\"".$class."\">".date(TIME_FORMAT,$IW->DB_Result($result,$i,"time_logged"))."</td>";
				echo "<td class=\"".$class."\">".$IW->DB_Result($result,$i,"ip")."<br />".$IW->DB_Result($result,$i,"browser")."<br /><a href=\"".$IW->DB_Result($result,$i,"referrer")."\" target=\"_blank\">".$IW->DB_Result($result,$i,"referrer")."</a></td>";
				echo "</tr>";
				if($row==0){$row=1;}
				else{$row=0;}
				}
			$IW->UI_CloseTable();
			$IW->DB_FreeResult ($result);
			$IW->UI_OpenTable();
			echo "<tr>";
			if ($_REQUEST['offset']!=0) 
				{
				$PrevPageAction=$_SERVER['PHP_SELF']."?cmd=".MODS_USE."&file=".MODULE_NAME;
				$PrevPageAction.="&offset=".($_REQUEST['offset']-3);
				$PrevPageButton=MODA_8;
				$IW->UI_OpenForm("",$PrevPageAction,"");
				echo "<td>".$IW->UI_Submit($PrevPageButton)."</td>";
				$IW->UI_CloseForm();	
				}
			$pages=intval($matches/10);
			if ($matches%10) {$pages++;}
			echo "<td>";
			for ($i=1;$i<=$pages;$i++) 
				{
				$newoffset=10*($i-1);
				$PageNumberLink=$_SERVER['PHP_SELF']."?cmd=".MODS_USE."&file=".MODULE_NAME;
				$PageNumberLink.="&offset=".$newoffset;
				$PageNumberLinkTitle=$i;
				echo "<a href=\"".$PageNumberLink."\">".$PageNumberLinkTitle."</a> \n";
				}
			echo "</td>";
			if (!(($_REQUEST['offset']/10)==$pages) && $pages!=1) 
				{
				$newoffset=$_REQUEST['offset']+10;
				$NextPageAction=$_SERVER['PHP_SELF']."?cmd=".MODS_USE."&file=".MODULE_NAME;
				$NextPageAction.="&offset=".$newoffset;
				$NextPageButton=MODA_9;
				$IW->UI_OpenForm("",$NextPageAction,"");
				echo "<td>".$IW->UI_Submit($NextPageButton)."</td>";
				$IW->UI_CloseForm();	
				}
			echo "</tr>";
			$IW->UI_CloseTable();
			}

		function PurgeStats ()
			{
			global $IW;
			$result=$IW->DB_Query("delete from ".TABLE_STATS);
			$IW->UI_Message(MODA_10);
			$IW->UI_Navigate($_SERVER['PHP_SELF']."?cmd=".MODS_USE."&file=".MODULE_NAME);
			}

	}

	$Mod = new ModuleAdmin ();
	$IW->UI_OpenWidget(MODA_11);
	if(!isset($_REQUEST['purge'])){$_REQUEST['purge']=0;}
	if($_REQUEST['purge']==1){$Mod->PurgeStats ();}
	else{$Mod->ViewStats ();}
	$IW->UI_CloseWidget();

?>